TAQOZ
( 4 TABS )

		*** SD CARD SUPPORT ***

IFDEF *FILE*
sdvars org
FORGET *FILE*
}

pub *FILE*		PRINT" TAQOZ FAT32 FILE SYSTEM for SD CARD plus VIRTUAL MEMORY  210122-0730" ;
{
210121	improved dir handling and saving - tested RENAME etc
		Added GETDIR SAVEDIR MODIFIED CREATED
		BACKUP <FILE> now time stamps the modified date and time (assuming RTC but test on non P2D2)
		Added timestamp to MBR boot signatue
		RW RWS permissions are non-resetting - use RO to reset permissions
210120	Standardized handling of directory record and also make it separate from file buffers etc.
}


org@	org ( marks start of block for DATLEN )
private
0	bytes	sdvars		--- mark start of variables array
4	bytes	ocr			--- operating conditions registers
16	bytes	cid			--- card ID
16	bytes	csd			--- card specific data
	long	sdsize		--- numbero of sectors
	long	@sdrd
	long	@sdwr
	long	sdsum		--- checksum of sector contents
	long	seccrc		--- sector crc

	long	readsect	--- current buffered sector
	long	filesect	--- starting sector of current file ( could be a directory)'
	long	opensect	--- starting sector of open file'

	long	_fread
	long	_fwrite
	long	mntd		--- serial number of mounted device
	word	_fkey

	byte	sdcmd
	byte	wrflg		--- true if sector has been modified
\	byte	mntd
\	byte	sdcrc

	byte	wrens		--- write enables
	byte	file#
	byte	fq			--- listing counter
	byte	sdhc
	byte	blklen
16 	bytes	bitbuf

	*** PARITION RECORDS ***

--- 4 primary partitions
64	bytes	parts		--- STATE,[HEAD,[SECT(2),TYPE,HEAD],SECT(2)],1STSECT(4),PARTSEC(4)
						---  00    82    03 00   0B   50    CA C6     $2000  $00ECC000
	word	parsig


	*** FAT32 BOOT RECORD ***

3	bytes	fat32		--- jump code +nop
8	bytes	oemname		--- MSWIN4.1
	word	b/s			--- 0200 = 512B (bytes/sector)
	byte	s/c			--- 40 = 32kB clusters (sectors/cluster)
	word	rsvd		--- 32 reserved sectors from boot record until first fat table
	byte	fats		--- 02
2	res					--- Maximum Root DirectoryEntries (non-FAT32)
2	res					--- Number of Sectors inPartition Smaller than 32MB (non-FAT32)
	byte	media		--- F8 hard disk  (IBM defined as 11111red, where r is removable, e is eight sectors/track, d is double sided. )
2	res					--- Sectors Per FAT in Older FATSystems (N/A for FAT32)
2	res					--- Sectors Per Track --- 3F 00
2	res					--- Number of Heads --- FF 00
	long	hidden		--- Number of Hidden Sectors before Partition --- 00 20 00 00
( 32 )
	long	s/p			--- $00EC_C000  Number of sectors * byte/sect (512) = capacity'
	long	s/f			--- $0000_0766 Number of sectors per FAT table'
2	bytes	fat?		--- 0000 fat flags (b3..0 = active fat copy, b7=mirroring)
2	res	fatver			--- 0000 fat version MAJOR.MINOR
( 44 )
	long	rootcl		--- $0000_0002 Cluster Number of the Start of the Root Directory'
	word	infosect	--- 0001 info = Sector Number of the FileSystem Information Sector  (from part start)
	word	bbsect		--- 0006 boot = Sector Number of the Backup Boot Sector (from part start)
12	res					--- 00s
( 64 )
	byte	ldn			--- 80 logical drive number of partition
1	res	ldnh			--- 01 unused or high byte of ldn
	byte	extsig		--- 29 extended sig
	long	serial		--- $63FE_C331 serial number of partition
11	bytes	volname		--- volume name
8	res	fatname			--- "FAT32   " always FAT32 - (don't trust)
2	res				--- align to a long for FREAD
( 90 )

--- --- --- --- --- --- --- --- --- --- --- --- --- ---

	long freeclusters	--- Read from info sector
	long lastcluster	--- Read from info sector
---	calculated from scan at mount
	long usedcl			--- Used Clusters
	long freecl			--- Free Clusters
	long used%			--- percentage used *100


	long mksiz		--- size used to create a file if file not found - 0 = none

--- --- --- --- --- --- --- --- --- --- --- --- --- ---
--- create room for some system variables in this table

	long	rootdir		--- sector address of root directory (MBR,GAP,BOOT,INFO,BACKUP,FAT1,FAT,ROOT)
	long	cwdir
	long	fat1
	long	fat2
	long	cwdsect
org@ sdvars -	:= sdsz		--- size of array used to hold all raw SD card related values + FAT etc
cwdsect fat32 - := fatsz	--- size of array used to hold all fat32 related values

14	bytes cwd$


\	!org --- reset org back to previous
public

BUFFERS			:= SDBUF	--- file sector buffers inital value

SDBUF 512 3 * +	:= DIRBUF	--- dir sector buffer

--- erase 4 sector buffers
pri !SDBUF							BUFFERS $800 ERASE ;



\ pub SDBUF		$1.0000 file# C@ 5 << + ;
\ pub FILE ( n -- )	3 AND file# C! ;

\ 61	:= SDCK
\ 60	:= SDCS
\ 59	:= SDDI
\ 58	:= SDDO

--- SD PIN VALUES
pub SDCK ( -- ck )			2 COG@ ;
pub SDDI ( -- di )			3 COG@ ;
pub SDDO ( -- do )			4 COG@
pub SDCS ( -- cs )			5 COG@ ;

--- select SD I/O for SPI operations
pri SDSPI				&60.58.59.61 SPIPINS ;
--- set SD PINS
pub SDPINS				AT SDSPI :=! ;
pub !SDIO				AT SDSPI 2+ 4 ADO IC@ FLOAT LOOP ;	--- release SPI I/O to SD

pub SD? ( -- flg )
	SDSPI
--- assume SD CD pin may be floating --- check for pullup
	SDCS LOW 2 us SDCS FLOAT 5 us SDCS PIN@ SDCS HIGH
--- clear mounted flag if SD not present
 	DUP ?EXIT mntd ~
	;

---					byte clocks
pri SDCLK				8 CLKS ; \ SDCK HIGH  ;
{
'+-----------------------------------------------------------------------------+
'+      /CS=1, Release SD Card DO pin, tristate SD CS/CK/DI/DO                 +
'+-----------------------------------------------------------------------------+
_releaseDO                                              ' if "NC" & "Z" = success
                call    #_sendFastFF                    ' releaseDO
                bith    sdx_bitout,      #sdx_cs        ' prepare /CS=1(disable)
                call    #_sendFastFF                    ' releaseDO again to be sure!

                flth    #sdx_cs                         ' tristate /CS
                fltl    #sdx_ck                         ' tristate CLK
                flth    #sdx_di                         ' tristate DI

  if_nc_and_z   mov     sdx_status,      #0             ' $0         = "NC" & "Z" = success
  if_c_or_nz    neg     sdx_status,      #1             ' $ffff_ffff = "C" | "NZ" = fail
                RET                                     '
}
pri RELEASE				SDCLK SPICE SDCLK SDCK HIGH !SDIO ;

pri SDCLK3				24 CLKS ;
--- clock SD for token but timeout & false if not found
pri TOKEN ( marker -- flgX )
	AT SDSPI 3 + C@ HIGH
	10000
		BEGIN OVER 0 SPIRD <>
		WHILE 100 us 1- DUP 0= IF NIP EXIT; THEN
		REPEAT
	2DROP TRUE
	;

--- SD COMMAND ---
pub CMD ( data cmd -- res ) ---  2,777 cycles= 13,885ns @200MHz
	DUP sdcmd C!
---	setup SD pins for SPI and preclock
	SDSPI SDCLK
---	write cmd and 32-bits of data
	SPIWC SPIWL
---	send a crc of CMD8 or CMD0 - others ignore value
	sdcmd C@ IF $87 ELSE $95 THEN SPIWB
pri SDRES
---	  retries for read until <> $FF
	0 50000 FOR SPIRD >B DUP $FF <> ?NEXT DROP
	;
pub ACMD ( data acmd -- res )
	0 55 CMD DROP CMD
	;
pri DAT?
	SDRES $FE =
	;

pri SDSTAT ( -- stat )	16 CLKS 0 13 CMD SDRES 8<< OR ;

\ pri SD4@ ( -- long ) 0 SPIRD SPIRD SPIRD SPIRD ;
pri SDDAT! ( adr -- ) --- read info into memory
	$FE TOKEN IF DUP 16 ADO 0 SPIRD I C! LOOP SDCLK3 THEN DROP
	;


--- CSD BIT FIELDS ---

pri XSHR
	FOR
	0 bitbuf 16
	  ADO IC@ DUP 2/ ROT OR I C!
	    1& IF $80 ELSE 0 THEN
	  LOOP
	 DROP
 	NEXT
	;

--- read bitfield range from CSD register
pri CSD@ ( bith bitl -- dat )
	csd
pri BITS@	( bith bitl adr -- dat )
	bitbuf 16 CMOVE
 	DUP XSHR - 1+ |<
	1-
	0 bitbuf 12 + 4 ADO 8 << IC@ OR LOOP
	AND
	;

--- init SD card into SPI mode
pri !SD!
	sdcmd C~~ 5 FOR 0 0 CMD 1 = ?NEXT 0EXIT
---	check operation conditions
	5 FOR $1AA 8 CMD 1 = ?NEXT 0EXIT
	0 SPIRL $1AA = 0EXIT
---	Issue ACMD 41 with slow clocks
	0 1000 0 DO 30 |< 41 ACMD IF 200 FOR SDCK HIGH 2 us SDCK LOW 2 us NEXT ELSE 1+ LEAVE THEN LOOP 0EXIT
---	operation conditions (voltages) note: spec says do this before acmd41 but does not work
	0 58 CMD ?EXIT 0 SPIRL DUP ocr ! 0EXIT
---	card information
	0 10 CMD 0= IF cid SDDAT! THEN
---	card specific data
	0 9 CMD 0= 0EXIT csd SDDAT!
	;

--- Initialise the SD card in SPI mode and return with the OCR
--- pub !SD ( -- ocr|false )
pub !SD ( --- ocr|false )
---	Reset SD power if UB3 is fitted (P2D2)
	UB? IF UBSD THEN
---	setupSD pins and reset variables and buffer
	SDSPI sdvars sdsz ERASE	!SDBUF readsect ~~
	SD? IF
	  SDCLK3 20 FOR
---	    attempt init and check if last operation was 9
	    !SD! sdcmd C@ 9 = DUP 0= IF 50000 CLKS THEN
	  ?NEXT
	  DROP SPICE 800 CLKS
	  69 48 CSD@ 1+ 10 <<   sdsize !
	THEN
	ocr @
	;

		--- CARD INFO ---

pri .LINE		CRLF 4 SPACES DUP PRINT$ LEN$
pri .LINE@		32 - ABS '.' SWAP EMITS SPACE ;
pri .***		SPACES ." ***" SPACE ;
pri .TITLE		CRLF CRLF 20 OVER LEN$ 2/ - .*** PRINT$ 1 .*** ;

{
	FORGET mfgs

128 TABLE mfgs \ $FF mfgs C!
\ pub ZLEN$ DUP BEGIN C@++ 0= UNTIL SWAP - ;
\ pub MFG		mfgs DUP LEN$ + 1+ ROT OVER C! 1+ $! ;
pub MFG		mfgs DUP LEN$ + 1+ ROT OVER C! 1+ $! ;
mfgs
	1 " PANASONIC"			MFG
	1 " PANASONIC"			MFG
	2 " TOSHIBA  "			MFG
	3 " SANDISK  "			MFG
	$1B " SAMSUNG  "		MFG --- PROGRADE
	$1D " AData    "		MFG
	$27 " PHISON   "		MFG --- AgfaPhoto, Delkin, Integral, Lexar, Patriot, PNY, Polaroid, Sony, Verbatim
	$28 " LEXAR PNY"		MFG
	$31 " SILICON POWER "	MFG
	$41 " KINGSTON "		MFG
	$74 " TRANSCEND"		MFG
	$76 " PATRIOT  "		MFG
	$82 " SONY     "		MFG
DROP
}

--- Print the card manufacturers name if known, otherwise report the code
pri .MFG
	SWITCH
	1 CASE   ." PANASONIC" BREAK
	2 CASE   ." TOSHIBA  " BREAK
	3 CASE   ." SANDISK  " BREAK
	$1B CASE ." SAMSUNG  " BREAK --- PROGRADE
	$1D CASE ." AData    " BREAK
	$27 CASE ." PHISON   " BREAK --- AgfaPhoto, Delkin, Integral, Lexar, Patriot, PNY, Polaroid, Sony, Verbatim
	$28 CASE ." LEXAR PNY" BREAK
	$31 CASE ." SILICON POWER " BREAK
	$41 CASE ." KINGSTON " BREAK
	$74 CASE ." TRANSCEND" BREAK
	$76 CASE ." PATRIOT  " BREAK
	$82 CASE ." SONY     " BREAK
	CASE@  ."  UNKNOWN" .B
	;

{
pub .CID
	" CID" .TITLE
	" BRAND" .LINE cid C@ .MFG
	" OEM ID" .LINE cid 1+ 2 CTYPE
	" PRODUCT" .LINE cid 3 + 5 CTYPE
	" REV" .LINE cid 8 + C@ .B
	" SERIAL#" .LINE cid 9 + @ PRINT
	" MFG" .LINE cid 14 + C@ cid 13 + C@ >N 8 << + DUP 4 >>  2000 + . >N .AS" /*|"
	" CRC" .LINE cid 15 + C@ DUP .B SPACE 1& ?EXIT
}

--- Print the CID information in verbose REPORT format
pub .CID
	PRINT"  CARD: "
pri .CARD
	cid C@ .MFG
	SPACE cid 1+ 2 CTYPE
	SPACE cid 3 + 5 CTYPE
	PRINT"  REV" cid 8 + C@ .B
	PRINT"  #" cid 9 + @ U.
	PRINT"  DATE:" cid 14 + C@ cid 13 + C@ >N 8 << + DUP 4 >>  2000 + PRINT >N .AS" /*|"
	cid 15 + C@ 1& ?EXIT
	PRINT"  BAD CID "
	;
{
TAQOZ# .CID ---  CARD: SANDISK   SD SC64G REV$80 #35190404 DATE:2018 /10 ok
}

\ 0=0.5 mA, 1=1 mA, 2=5 mA, 3=10 mA, 4=25 mA, 5=35 mA, 6=60 mA, 7=100mA
\ 0=1 mA, 1=5 mA, 2=10 mA, 3=25 mA, 4=35 mA, 5=45 mA, 6=80 mA, 7=200

private
0 TABLE ma	0 | 1 | 5 | 10 | 25 | 35 | 60 | 100 | 1 | 5 | 10 | 25 | 35 | 45 | 80 | 200 |

\ Card information
pri .ma		ma + + C@ ?DUP IF .DECL ELSE ." 0.5" THEN ." ma" ;
pri .CURRENT
	  " Iread Vmin" .LINE	61 59 CSD@ 0 .ma
	  " Iread Vmax" .LINE	58 56 CSD@ 8 .ma
 	  " Iwrite Vmin" .LINE	55 53 CSD@ 0 .ma
	  " Iwrite Vmax" .LINE	52 50 CSD@ 8 .ma
	  ;


pri .xs ( ns -- )
	DUP 1 M => IF 1 M / .AS" #~#ms" EXIT THEN
	DUP 1,000 => IF 1,000 / .AS" #~#us" EXIT THEN
	.AS" #~#ns"
	;

private
--- CSD timing values lookup table
0 TABLE tval
	&13.12.10.00 ,
	&30.25.20.15 ,
	&50.45.40.35 ,
	&80.70.60.55 ,

pri TACC ( -- ns )
	119 112 CSD@ --- b6..3=tval b2..0=tru
	DUP 3 >> tval + C@ ( *10)
	SWAP 7 AND 1 SWAP 1+ FOR 10 * NEXT 100 / *
	;
pri .TACC
	" LATENCY" .LINE
 	TACC .xs
	119 112 CSD@ ?DUP 0EXIT 100 * .AS" +*|# clocks "
	;

pri .TRANS
	" SPEED" .LINE
	103 96 CSD@ .AS" ##MHz "
	;

--- Print the CSD information in verbose report format
pub .CSD
	sdhc C~
	" CSD" .TITLE
	127 126 CSD@
	IF
	  " CARD TYPE" .LINE 	." SDHC" sdhc C~~
	  .TACC  .TRANS
	  " CLASSES" .LINE 	95 84 CSD@ 20 << REV 12 .BITS
 	  " BLKLEN" .LINE	83 80 CSD@ DUP blklen C! |< .DECL
---	                                    total sectors
	  " SIZE" .LINE  	sdsize @ 2000 U/ .DECL ." MB"
	  .CURRENT
	  EXIT;
	THEN
	."  NOT SDHC!"
	;
{
TAQOZ# .CSD ---

                   *** CSD ***
    CARD TYPE....................... SDHC
    LATENCY......................... 1ms+1400 clocks
    SPEED........................... 50MHz
    CLASSES......................... 0 1 0 1 1 0 1 1 0 1 0 1
    BLKLEN.......................... 512
    SIZE............................ 62,367MB
    Iread Vmin...................... 10ma
    Iread Vmax...................... 25ma
    Iwrite Vmin..................... 60ma
    Iwrite Vmax..................... 35ma ok
}

--- Print card Operating Conditions Register in verbose report format
pub .OCR
	" OCR" .TITLE
	" VALUE" .LINE ocr @ .L ( $C0FF_8000 )
	ocr @ 30 >> 3 <> IF ."  invalid!" THEN
	" RANGE" .LINE
	27 ocr @ 15 >> $1FF AND BEGIN DUP 1& 0= WHILE 2/ b++ REPEAT OVER .AS" #.#V to "
	BEGIN DUP 1& WHILE 2/ b++ REPEAT DROP .AS" #.#V"
	;
{
TAQOZ# .OCR ---

                   *** OCR ***
    VALUE........................... $C0FF_8000
    RANGE........................... 2.7V to 3.6V ok
}

--- FILE PERMISSIONS ---


pub RO		wrens C~ ;			--- Read only - write protected
pri wm		wrens SET ;
pub RW		1 wm ;		--- Read/Write access - write enabled
pub RWC		3 wm ;		--- Read/Write & create
pub RWS		7 wm ;		--- Read/Write/System permission
pri RW?		1 wrens SET? ;

pri B>S ( bytes -- sectors )	L>S SWAP IF 1+ THEN ;


		*** SD CARD MEMORY ACCESS ***

pri SDWR?	@sdwr @ ;

pub SDWR ( src sect --  )
	@sdwr ~
---	never sector 0 or if write protected unless RWS used
	DUP 0<>	 RW? AND 4 wrens SET? OR
	IF
---	 sector write command
	 SDCLK3  24 CMD
	  IF DROP
---		    start token, data
	  ELSE SDCLK3 $FE SPIWB 512 SPITX
---	    read data response
	    0 TOKEN $FF TOKEN AND
	  THEN
---	 always reset any RWS permissions after op - set crc in sdwr
	  4 wrens CLR   @sdwr ! RELEASE
	BREAK
---	else write protect fail
	2DROP
	;

--- SD WRTIE MULTIPLE SECTORS
pub SDWRS ( ram sector bytes -- )
	@sdwr ~ RW?
	IF
	  B>S --- convert bytes to sectors
	  ADO
	    DUP I SDWR 512 + SDWR? 0= ?LEAVE
	  LOOP
	  DROP RELEASE
	BREAK 3DROP
	;

--- only flush sector if it has been written to
pub ?FLUSH
	wrflg C@ 0EXIT
pub FLUSH
	SDBUF readsect @ SDWR wrflg C~
	;

pri SDRDBLK ( dst -- crc/flg )
	512 SPIRX \ sdsum !
	0 SPIRD SPIRD 31 |< OR
	;

pub SDRD ( sector dst --  ) --- read sector into memory and update sector number
	OVER readsect !
pub SDRDX ( sector dst -- ) --- read sector into memory silently
	SDCLK SWAP 17 CMD DUP 0=
	IF DROP DAT?
	  IF SDRDBLK ELSE SDSTAT 2DROP 0 THEN
	THEN
---	save crc as a flag  -- only lower 16-bits of seccrc = crc with flag in b31
	DUP @sdrd ! seccrc !
	RELEASE
	;


pri SDWAIT --- wait for data token with timeout (only used in SDRDS)
	1000 BEGIN 1- DAT? OVER 0= OR UNTIL 0=
	;

--- read multiple sectors in continuous multiblock mode -- update @sdrd pointer
pub SDRDS ( sector dst bytes --  )
---	convert bytes to sectors
	B>S
---	multiblock read
	-ROT SWAP 18 CMD
	IF --- command not accepted
	  2DROP FALSE
	ELSE ( sectors dst ) --- process read token and read block if available '
	  DAT?
	  IF --- data available, read in a block
	    SWAP FOR DUP SDRDBLK DROP 512 + SDWAIT ?NEXT
	  ELSE --- no more data available, terminate
	    2DROP SDSTAT DROP SPICE FALSE
	  THEN
	THEN
---	update the read index
	RELEASE  @sdrd !
---	cancel multiblock read on error
	  2000 BEGIN 1-   0 12 CMD 0=   OVER 0=   OR UNTIL DROP
	RELEASE
	;



	*** SECTOR ***


--- Always read in a sector but flush first
pub SECTORF ( sect -- sdbuf )
	?FLUSH SDBUF SDRD	\ 2048 SDRDS
	SDBUF
	;

--- S>M
pub SECTOR ( sect -- sdbuf )
	DUP readsect @ <> IF SECTORF EXIT; THEN
	DROP SDBUF
	;


--- return starting sector at current FILE
pub @FILE ( -- sector )			filesect @ ;

pub @OPEN ( -- sector )			opensect @ ;

--- Set the starting sector for file access
pub OPEN-SECTOR					_fread ~ filesect ! ;




	*** VIRTUAL MEMORY OPERATORS ***


{ ASM CODE PATCH TO SPEED UP SD VIRTUAL ADDRESSING

pri SDADR? ( sdadr -- ramadr | ramadr sector )
	ASM:
	mov	x,a
	zerox	a,#8		' a = offset in sector '
	add	a,#SDBUF	' a = hub ram address'
	shr	x,#9		' x = relative sector '
	rdlong	y,#filesect	' y = starting sector'
	add	x,y		' x = abs sector'
	rdlong	y,#readsect	' then compare with current sector'
	cmp	x,y wz		' still the same sector?'
 if_z	>EXIT			' yes, fast exit from threaded with ram address'
 if_nz	>PUSHX			' else continue to read sector'
	ret
	end

--- convert a file offset to a buffered address in hub ram
pub SDADRF ( addr -- ramaddr )	SDADR? ?FLUSH SDBUF SDRD ;

--- 			dynamic patch to SDADRF
pri PATCH		AT SDADRF R> 2- W! SDADRF ;

--- dynamically patch any routines that call SDADR to directly call SDADRF instead
AT PATCH 1+ AT SDADR W!	( PATCH SDADR with fast SDADR )

}

--- Convert SD file address to hub ram address where file is buffered (897 cycles= 4,485ns @200MHz)
pub SDADR ( sdadr -- ramadr )		L>S @FILE + SECTOR + ;

--- fetch long from SD virtual memory in current file
pub SD@ ( xaddr -- long )		SDADR @ ;
pub SDW@						SDADR W@ ;
pub SDC@ ( sdaddr -- byte )		SDADR C@ ;

--- store long to SD virtual memory in current file
pub SD! ( data xaddr -- )		SDADR ! wrflg C~~ ;
pub SDC!						SDADR C! wrflg C~~ ;

--- select SD for DUMP method : use: 0 $200 SD DUMP
pub SD							' SDC@ ' SDW@ ' SD@ DUMP! ;



	*** FAT32 ***


--- at ROOT sector
pub @ROOT ( -- sector )			rootdir @ ;
pub @CWD						cwdir @ ;
pub CWD!						cwdir ! ;

--- at BOOT sector
pub @BOOT ( -- sector )			parts 8 + @ ;
pri @FAT ( fat# -- sector )		s/f @ * @BOOT rsvd W@ + + ;

pri FATSZ ( -- fatsz )			sdsize @ @BOOT - ;



--- open directory sector as a file

--- Open the root folder as a file
pub ROOT						" /" cwd$ $! @ROOT CWD!
--- open the current working dir as if it were a file
pub CWD							@CWD OPEN-SECTOR ;

--- Use the MBR as a file
pub MBR 						0 OPEN-SECTOR ;

--- access FAT1 or FAT2 as a file
pub FAT1						fat1 @ OPEN-SECTOR ;
pub FAT2						fat2 @ OPEN-SECTOR ;


--- change current working directory
pub CD# ( sect -- )				cwdsect ! ;


--- Close file by flushing, switching to read-only and use sector 0
pub CLOSE-FILE
pub FCLOSE						FLUSH RO MBR readsect ~~ ;




	*** DIRECTORY STRUCTURE ***

public --- 8.3 directory entry structure
0 bytes dirrcd
\ private
8 bytes fname
3 bytes fext
1 bytes fatr		---  (0:read-only, 1:hidden, 2:system, 3:volume label, 4:directory, 5:archive, 6-7: undefined)
1 res 0
1 bytes fcms		--- file creation time - milliseconds
2 bytes fctime
2 bytes fcdate
2 bytes fadate
2 bytes fclsth
2 bytes ftime
2 bytes fdate
2 bytes fclstl
4 bytes fsize

public
2 bytes	diridx		--- directory index
16 bytes file$



pub FSIZE@	fsize @ ;


		*** CLUSTERS ***
{

FAT32 allocation units are clusters of sectors.
A card is formatted	as 512,1K,2K,4K,8K,16K,32K,64K clusters

...............MEDIA
0001_0000: 0FFF_FFF8 0FFF_FFFF 0FFF_FFF8 0000_0004     '................'
0001_0010: 0000_0005 0000_0006 0000_0007 0000_0008     '................'
0001_0020: 0000_0009 0000_000A 0000_000B 0000_000C     '................'
0001_0030: 0000_000D 0000_000E 0000_000F 0000_0010     '................'
0001_0040: 0000_0011 0000_0012 0000_0013 0000_0014     '................'
0001_0050: 0000_0015 0000_0016 0000_0017 0000_0018     '................'
0001_0060: 0000_0019 0000_001A 0000_001B 0000_001C     '................'
0001_0070: 0000_001D 0000_001E 0000_001F 0000_0020     '............ ...'
0001_0080: 0000_0021 0000_0022 0FFF_FFFF 0000_0000     '!..."...........'
0001_0090: 0000_0000 0000_0000 0000_0000 0000_0000     '................'

  1:   _BOOT_P2.BIN 20 $0000_5B26   2018-12-24 06:48   X...P2D2F   ....   131,072  ok
TAQOZ# @ROOT .L --- $0000_5B1E ok
TAQOZ# s/c C@ . --- 8 ok


CLUSTER0 = MEDIA BYTE
CLUSTER1 = b27 = clean ; b26 = no errors

}



{ CLUSTER CHAIN CODES
If value => $0FFF.FFF8 then there are no more clusters in this chain.
$0FFF.FFF7 = bad
0 = free

}
pri @CLUSTER ( index -- xadr )		FAT1 4* ;

pri CLUSTER@ ( index -- cluster )	@CLUSTER SD@ ;


pri FreeClusters? ( size -- #clusters clust1 )
	--- calculate clusters required
     B>S s/c C@ U/ ( clusters )
      0
     BEGIN
       --- find a free cluster
       BEGIN DUP CLUSTER@ WHILE 1+ REPEAT
       --- check for sufficient contiguous clusters ( clusters index )
       0 OVER 3RD ADO I @CLUSTER SD@ OR DUP IF NIP I SWAP LEAVE THEN LOOP
       ( clusters chain flag )
     WHILE
       1+
     REPEAT
     ;



--- count number of clusters allocated from start cluster
pub CLUSTERS? 	( cluster# -- clusters )
--- scan through fat1 as a file
	filesect @ SWAP
	0 SWAP  ( cnt sect -- )
	BEGIN b++ CLUSTER@ DUP $0FFF_FFF8 => UNTIL DROP
	SWAP filesect !
	;

--- Convert Directory address to first cluster
pub FCLUSTER ( -- cluster#0 )
---	cluster low and cluster high combined
	fclstl W@ fclsth W@ W>L
	;

--- read Directory cluster and convert to starting sector
pub FSECTOR ( -- sector )
	FCLUSTER
--- Convert Cluster to sector
pub C>S ( clust# -- sector )
	rootcl @ -
pri C>S2
	s/c C@ * @ROOT +
	;

--- convert a sector to a cluster ( result 0 = out of range  ; 2 = 1st )
pub SECT>CLST ( sector -- cluster )
	@CWD - s/c C@ U/ 2+
	;

--- convert sector to total allocated clusters
pri SECT>CLST# ( sector -- clusters )
	SECT>CLST CLUSTERS? s/c C@ * 9<<
	;

pri ?FREE
---	Calculate used/unused
	0 0 usedcl 12 ERASE
	sdsize @ @ROOT - ( data-sectors )
	s/c C@ U/ ( data-clusters ) 2+ ( where root is cluster 2 )
	2 DO I CLUSTER@ IF b++ ELSE 1+ THEN LOOP
	2DUP + 3RD 10000 * SWAP U/
	used% ! freecl ! usedcl !
	;

pub GETFAT
---	read fat32 as a byte array
	@BOOT SECTORF fat32 90 CMOVE
---	sectors rsvd to fat1  ... size of fat tables
	rsvd W@                s/f @ fats C@ *  + ( offset from fat boot )
\	rootcl @ 2- C>S2
	hidden @ + 	rootdir !
---	'' save time by precalculating FAT table addresses@
	0 @FAT fat1 ! 1 @FAT fat2 !
	\ ?FREE
---	Open info sector
	@BOOT infosect W@ + OPEN-SECTOR
	$1E8 SD@ freeclusters !
	$1EC SD@ lastcluster !
	;


--- find total allocated cluster bytes for this byte
pub FMAX ( -- bytes )		FCLUSTER CLUSTERS? s/c C@ * 9<< ;

{
00h 	First Signature (52h 52h 61h41h) 	1 Double Word
04h 	Unknown, Currently (Mightjust be Null) 	480 Bytes
1E4h 	Signature of FSInfo Sector(72h 72h 41h 61h) 	1 Double Word
1E8h 	Number of Free Clusters (Setto -1 if Unknown) 	1 Double Word
1ECh 	Cluster Number of Clusterthat was Most Recently Allocated. 	1 Double Word
1F0h 	Reserved 	12 Bytes
1FCh 	Unknown or Null 	2 Bytes
1FEh 	Boot Record Signature (55hAAh) 	2 Bytes
}

pri SDBUF+ ( offset -- adr )		SDBUF + ;

pub MOUNT
	SD? 0EXIT !SD DROP !SD DROP !SD 0EXIT

	0 SECTORF $1FE + W@ $AA55 <> " INVALID PARTITION" ?ERROR
	$1BE SDBUF+ parts 66 CMOVE
	fat32 fatsz ERASE
	RO --- disable sector sdwr
	GETFAT
	ROOT serial @ mntd !
--- PRINT CID AS CONFIRMATION
	.CID
	1 MB mksiz !
	;
---	MOUNT FAT32 if not already mounted
pub ?MOUNT
	SD? serial @ mntd @ = AND mntd @ 0<> AND 0=
	  IF 10 ms MOUNT ( $0D KEY! ) ELSE SD? 0= IF mntd ~ THEN THEN
	;
pub MOUNTED?
	?MOUNT mntd @
	;







		*** DIRECTORY ***


--- save file name in file$ but convert to 8.3 format in dir
pub AS8.3 ( str -- )
	DUP file$ $!		--- save original
	fname 11 $20 FILL
---	str buf
	fname OVER LEN$ 0 DO
	  OVER I+ C@ a>A
	  DUP '.' = IF 2DROP fext ELSE OVER C! 1+ THEN
	LOOP
	2DROP
	;


--- reads relevant dir sector in using index
---	returns with the address in the buffer
pub IDX>DIR ( dirIndex -- diradr )
	diridx W!
pub >DIR
	diridx W@ CWD 5 << SDADR
	;
--- read the nth directory entry into the dir buffer (index saved in diridx)
pub GETDIR ( index -- )
	IDX>DIR fname 32 CMOVE
	;

pub SAVEDIR
---	update directory on SD
	fname >DIR 32 CMOVE
	RW FLUSH RO
	;

pub OPENDIR
	FSECTOR OPEN-SECTOR
	;

16 bytes f$	--- copy of 8.3 name in normal short format
--- divert output to f$ to build a file name - then used for formatting
pri $EMIT	f$ ~ EMIT: f$ DUP LEN$ + W! ;

pri FTYPE ( from cnt -- )		ADO IC@ $20 > IF IC@ .EMIT THEN LOOP ;

--- Print the file name of the current dirbuf
pub .FNAME
--- skip invalid index/entry
	$EMIT fname C@ $20 >
     IF
       $10 fatr SET? IF '[' EMIT THEN
       fname 8 FTYPE
	   fext C@ $20 > IF '.' EMIT fext 3 FTYPE  ELSE 4 SPACES THEN
       $10 fatr SET? IF ']' EMIT THEN
     THEN
	EMIT; f$ PRINT$
;

pri .ASMONTH ( index -- )
     >N 1- 3 *
     " JanFebMarAprMayJunJulAugSepOctNovDec" + 3 CTYPE
     ;

--- print date in Unix format
pri .ASDATE ( fdate -- )
--- extract day of the month to index into name string
     DUP 5 >> .ASMONTH
--- day of the month
      $1F AND 3 U.R
     ;
pri .ASTIME ( ftime -- )
      DUP 11 >> .DEC2 ':' EMIT
      5 >> 6 BITS .DEC2
     ;

pri .ASYMD
	DUP 9>> 1980 + .DEC4
--- print month-day
	DUP 5 >> >N '-' EMIT .DEC2 $1F AND '-' EMIT .DEC2
	;

--- print the file date
pub .FDATE
---	print year from 1980
	fdate W@ .ASYMD
---	print time as hh:mm
	ftime W@ .ASTIME
	;


--- split 6 digit decimal number into 3 two digit groups
pub HMS ( #xxyyzz -- zz yy xx )		100 U// 100 U// ;

--- update file modification/create time in dir buf
--- Time (5/6/5 bits, for hour/minutes/doubleseconds)
pub FTIME! ( #hhmmss field -- )
	SWAP HMS 11 << SWAP 5 << + SWAP 2/ +
	SWAP W!
	;


--- update file modification/create date in dir buf
--- Date (7/4/5 bits, for year-since-1980/month/day)
pub FDATE! ( #yymmdd field -- )
	--- arrange as decimal YYMMDD from 1980 ( 2000.0000 + 1980.0000 - )
	SWAP DUP 2000.0000 < IF 200000 + THEN
	HMS 9 << SWAP 5 << + +
	SWAP W!
	;

--- DATE TIME STAMPING ---

--- Update the modified time and date of the current file
pub MODIFIED ( -- )
	TIME@ ftime FTIME!
	DATE@ fdate FDATE!
	SAVEDIR
	;
pub CREATED ( -- )
	TIME@ fctime FTIME!
	DATE@ fcdate FDATE!
	SAVEDIR
	;




{ DIRECTORY STRUCTURE

public --- 8.3 directory entry structure
0 bytes dirbuf
private
8 bytes fname
3 bytes fext
1 bytes fatr		---  (0:read-only, 1:hidden, 2:system, 3:volume label, 4:directory, 5:archive, 6-7: undefined)
1 res 0
1 bytes fcms
2 bytes fctime
2 bytes fcdate
2 bytes fadate
2 bytes fclsth
2 bytes ftime
2 bytes fdate
2 bytes fclstl
4 bytes fsize
}

pri ACTIVE? ( -- flg )	seccrc @ $8000.0000 <> ;

pri .DIR 	NOP NOP ;

pri DIR: ( code -- )
    ?MOUNT CRLF volname 11 CTYPE
\	PRINT"      ATR  SECTOR     MODIFIED               SIZE              MAX"
pri LIST: ( -- )
    R> AT .DIR W!   fq C~   FCLOSE
    s/c C@ 4 << 0
    DO
      I GETDIR ACTIVE?				--- continue if the whole sector has entries
      IF
        fatr C@ $0F >            	--- accept only valid entries
    	fname C@ $80 < AND          --- but ignore if 1st character has 8th bit set
        fname C@ '?' <> AND         --- ignore "deleted" entries
          IF .DIR THEN        		--- all good, list this one using the directed method (210120 entry copied into dir buf )
      ELSE
        LEAVE                    	--- no more dir sectors - leave loop
      THEN
    LOOP
    ;


pub DIRW		 DIR: fq C@ 8 // 0= IF CRLF THEN .FNAME 14 f$ LEN$ - SPACES fq C++  ;
{
P2 CARD         ATR  SECTOR     MODIFIED               SIZE              MAX
[BMP    ]       10 $0000_BC16   2021-01-21 18:00              0 /        65,536   .;,j,R,R
}
pri .DHD		CRLF PRINT" NAME...........ATR.1ST.SECTOR...MODIFIED.............FILE.SIZE.......MAX.SIZE.....HEADER" ;

pub DIR
	.DHD
	DIR:
pri	ASDIR
	CRLF .FNAME 16 f$ LEN$ - SPACES
---	print atr
	fatr C@ DUP .BYTE SPACE 8 AND 0=
	  IF --- not a directory - so list file info
---	 $0000_9678   2018-12-24 02:56
	  FSECTOR .L	 3 SPACES 	fdate W@ .ASYMD  SPACE ftime W@ .ASTIME
---	 display file size
	  SPACE FSIZE@ 14 .DECS
	THEN
	;

pri .HEADER
	3 SPACES FSECTOR SECTOR 20 FTYPE
	;
pri .ASIZE
---	  print total allocated memory via clusters
	FSIZE@ 27 >> NOT IF  PRINT"  /" FMAX 14 .DECS THEN
	;

{
P2 CARD
[BMP    ]       10 $0000_BC16   2021-01-21 18:00              0 - created 2021-01-21 18:07.038 - accessed Jan 21
}
pub DIR++		.DHD DIR:	ASDIR SPACE PRINT" - created " fcdate W@ .ASYMD SPACE fctime W@ .ASTIME fcms C@ .AS" .### - accessed " fcdate W@ .ASDATE ;

pub DIR+		.DHD DIR: 	ASDIR .ASIZE .HEADER ;

pub .LIST
	LIST:
	PRINT" -rwxrwxrwx 1 502     500"				--- dummy permissions
--- print file size "1048576"
	FSIZE@ .AS"  9|\# "
--- DATE "24"
	fdate W@ .ASDATE
--- most systems expect either the time or the year if it is older than 6 months
    2 SPACES ftime W@ .ASTIME
    SPACE .FNAME CRLF						--- FILE NAME "LOG0001.TXT"
    ;


--- list the directory in wide and simple format
--- ls -l in long format
pre ls
     delim 1+ C@ $20 =
     IF
       GET$ " -l" $=
       IF CRLF .LIST EXIT; THEN
     THEN
     DIRW
    ;































--- Load text input from a sector
pub FLOADS ( sector -- ) --- load file as console input then restore on null to console input '
	OPEN-SECTOR ukey W@ _fkey W!
	KEY:
pub FGET ( -- ch ) --- Read the next byte from the file
	_fread @ SDC@ DUP
	  IF _fread ++ EXIT THEN
	_fkey W@ ukey W! _fkey W~
	;

--- Read file offset to memory
pub FREAD ( sdsrc hubdst bytes -- )
	4 ALIGN ADO DUP SD@ I ! 4+ 4 +LOOP DROP
	;
--- Write memory to file offset
pub FWRITE ( hubsrc sddst bytes -- )
	4 ALIGN ADO DUP @ I SD! 4+ 4 +LOOP DROP
	;








--- open a file using the directory name index
pub FOPEN# ( index -- )
	GETDIR OPENDIR
	;



--- find current f83 name index+1 to directory entry
pri FIND-FILE ( str -- index+1 )
---	convert and save in X$ for comparisons
	AS8.3 fname X$ 11 CMOVE
	0  ( result)
	s/c C@ 4 << 0 DO
---	  buffer dir enty into memory and check
	  I GETDIR fname X$ 11 C$=
	    IF DROP I 1+ LEAVE THEN
	LOOP
	;


--- Find the next free directory entry (just looks for a null but could do more)
--- no range checking just to keep it simple for now
pub FREEDIR ( ---  )
	s/c C@ 4 << 0 DO I GETDIR fname C@ 0= IF LEAVE THEN LOOP
\	CWD 0 BEGIN DUP SDC@ WHILE 32 + REPEAT
	;

--- xx
pri ClaimClusters ( for from -- from )
     FAT1 \ RW
     DUP 3RD ADO 1 I+ I @CLUSTER SD! LOOP					--- link clusters
     ( #clusters clust1 )
     SWAP OVER+ 1- $0FFFFFFF SWAP @CLUSTER SD!					--- mark end cluster
     FLUSH
     ;


--- Create a new file by name but if it already exists then delete the old one and reuse the dir entry.
--- if size = 0 then max = 4GB

pre mk  [G] GET$
pub mk$ ( size namestr --  )
	FREEDIR
	--- as 8.3 and write the name of the file to the directory buffer
	fname 32 ERASE AS8.3  $20 fatr C!
	--- Set size of file to maximum & preallocate clusters
	DUP fsize ! FreeClusters? ClaimClusters ( from )
	--- write first cluster
	CWD L>W fclsth W! fclstl W!
	--- add directory record to directory
	CREATED MODIFIED SAVEDIR
    ;


{

64 KB MAKE OPEN-FILE <name>


}

--- Force file open  - create to size of it not found
pub MAKE ( size -- )	mksiz ! RWC ;


pub REOPEN-FILE
	file$
pub FOPEN$ ( str -- flg )
\	DUP file$ $!
---	check mount and find 8.3 file name
	?MOUNT FIND-FILE
---	if found then convert directory entry to starting sector
	IF FSECTOR
	ELSE
---	else if create flag set then create a preallocated size file  - else fail
	  2 wrens SET? IF mksiz @ file$ mk$ FSECTOR  ELSE 0 THEN
	THEN
---	open the sector although 0 = fail (mbr sector 0 is protected anyway)
	OPEN-SECTOR
	@FILE DUP opensect !
	;

--- File Open using name in stream - use @FILE to return file sector handle which is 0 if not open
pre FOPEN ( <name> -- )
---	execute any preceding code which may be permissions or options, then get string from console
	[G] GET$ SPACE
	FOPEN$ ?DUP IF PRINT" Opened @ " .L ELSE PRINT" not found " THEN
	;


ALIAS FOPEN$ OPEN-FILE$
ALIAS FOPEN OPEN-FILE


pre cwd ( <dir> -- )
pre CD
	[C] FOPEN @FILE CWD!
	file$ cwd$ $!
	;


pub pwd		cwd$ PRINT$ ;

pre DEL-FILE ( <name> -- )
\	OPEN-FILE
	;


pre SAVETEXT
	[C] FOPEN
	@FILE 0= IF 1 MB MAKE file$ FOPEN$ 0EXIT THEN
	0 BEGIN WKEY DUP $1B <> WHILE OVER SDC! 1+ REPEAT
	DROP 0 SWAP C! FCLOSE
	;

--- Send all output to the file if open - wraps using FSIZE
pub FSEND
	@FILE 0EXIT FSIZE@ 0EXIT
	_fwrite @
pri	FSEND! ( addr -- )
	_fwrite !
	RW EMIT:
	_fwrite @ SDC! _fwrite @ 1+ FSIZE@ // _fwrite !
	;

pre FLOAD ( <name> -- )
	[C] FOPEN @FILE FLOADS
	;

--- rename by refering to its index
pre RENAME# ( dir# <new> -- )
	[G] GETDIR
	GET$ AS8.3 SAVEDIR
	;

pre RENAME ( <old> <new> -- )
	GET$ FIND-FILE
--- replace old name with new and save
	  IF GET$ AS8.3 SAVEDIR TRUE
	  ELSE
	  FALSE
	  THEN
	  .SUCCESS
	;

pre cat
	[C] FOPEN \ 0 SD PRINT$
	@FILE 0EXIT
pub (cat)
	0 0 BEGIN
	  OVER SDC@ KEY $1B <> AND WHILE
	  OVER SDC@ $0A =
	    IF DUP $0D <> IF CR THEN ELSE DUP $0D = IF $0A EMIT THEN THEN
	  DROP DUP SDC@ DUP EMIT
	  b++
	REPEAT
	2DROP CRLF
	;

pre QV
	[C] FOPEN 0 SDADR $80 DUMP
	;

{


--- reverse dump listing back into memory
pre ..
	[G] BEGIN GET$ DUP @ OVER 1+ ! '$' OVER C!
	 NUMBER 2 = WHILE OVER C! 1+ REPEAT DROP [C] \
	;

$7F9A0 .. 53 49 54 45  30 30 30 32  4C 4F 47 20  00 1F FB 6E     'SITE0002LOG ...n'
$7F9B0 .. 2C 52 58 44  00 00 E6 23  58 44 37 B4  00 00 10 00     ',RXD...#XD7.....'

}




		*** DISK REPORTING ***

pub *DISK*	PRINT" SD DISK REPORTING & FORMATTING TOOLS 190800-0000" ;

pri .SPD ( offset sector -- )
	CNT@ 8 FOR OVER SDBUF SDRD NEXT
	CNT@ - ABS 3 >> CLKMHZ U/ ROT - .AS" *|#us" DROP
	;
pub .SPEEDS
	" SPEEDS" .TITLE
 	CNT@ SDBUF SDRDBLK DROP CNT@ - ABS CLKMHZ U/ ( readspeed )
	" LATENCY" .LINE 8 FOR DUP I 20 << .SPD ',' EMIT NEXT DROP

---				  Up to 4GB print sector speed in 0.5GB increments
	" SECTOR" .LINE 8 FOR 0 I 20 << .SPD ',' EMIT NEXT
---	Read a 256k block into unused memory
	" BLOCKS" .LINE 0 $8.0000 $4.0000 LAP SDRDS LAP
---	Report the equivalent multi-block read speed
	CLKHZ $4.0000 1000 / LAP@ U*/ .DECL ." kB/s @" .CLK
	;

pub .SD
	.CID .OCR .CSD .SPEEDS
	;

		*** PARTITIONS ***

--- Check file system type and return with known name
pri ?FS ( n -- str/flg )
	SWITCH
	11 CASE " FAT32 CHS" BREAK
	12 CASE " FAT32 LBA" BREAK
	7 CASE " exFAT?" BREAK
	6 CASE " FAT16" BREAK
	FALSE
	;

--- Print Cylinder Head Sector
pri .CHS ( xxcccshh -- )
	24 BITS
	DUP 16 >> OVER 14 >> 3 AND 8 << + PRINT ',' EMIT
	DUP >B PRINT ',' EMIT
	8>> $3F AND PRINT
	;



{
Disk /dev/sdb: 7948 MB, 7948206080 bytes
255 heads, 63 sectors/track, 966 cylinders, total 15523840 sectors
Units = sectors of 1 * 512 = 512 bytes
Sector size (logical/physical): 512 bytes / 512 bytes
I/O size (minimum/optimal): 512 bytes / 512 bytes
Disk identifier: 0x000edc02

    CHS START....................... 1023,254,63
    CHS END......................... 1023,254,63

HHHHHHHH,CCSSSSSS,CCCCCCCC


}
pub FORMAT.MBR
	!SDBUF
---	copy boot config table for reference in unused area at start
	0 SDBUF $100 CMOVE
---	MBR NAME OF FORMAT TOOL
\	" TAQOZ V2" 3 SDBUF+ $!
--- 1023, 254, 63
	parts 66 ERASE
---	valid partition flags
	$AA55 parsig W!

\	$80 parts C!
---	fs+CHS
	$0CFFFFFE parts 1+ !
--- This sets up 4MB hiddenbefore parition according to SD compliance (But >32GB 16MB)
	sdsize @ 70,000,000 U> IF $8000 ELSE $2000 THEN  parts 8 + !
---	TOTAL SECTORS = SDSIZE-<hidden>
	FATSZ parts 12 + !
---	copy parts to buffer
	parts $1BE SDBUF+ 66 CMOVE
---	Write MBR
	RWS SDBUF 0 SDWR
	;

--- Fetch sectors, print, and display in MB as well (  15,515,648 = 7,944MB )

pri .MBS ( adr -- )
	@ DUP .DECL ."  = "
pub .MB ( sectors -- )
	512 1,000 U*/
	DUP 1,000 U<
	IF .DECL ." kB"
	ELSE 1,000 U/ .DECL ." MB"
	THEN
	;

pub .MBR
	" MBR" .TITLE
---	Scan all 4 antries : check active partition type
	4 0 DO I 4 << parts + DUP 4+ C@
	  IF
	    " PARTITION" .LINE I PRINT SPACE DUPC@ DUP .BYTE SPACE 0= IF ." IN" THEN ." ACTIVE"
	    " FILE SYSTEM" .LINE DUP 4+ C@ ?FS ?DUP IF PRINT$ ELSE ." UNFORMATTED " THEN
	    " CHS START" .LINE 1+ DUP @ .CHS
	    " CHS END" .LINE 4+ DUP @ .CHS
	    " FIRST SECTOR" .LINE 3 + DUP @ .L
	    " TOTAL SECTORS" .LINE 4+ .MBS
	    CRLF
	  ELSE DROP
	  THEN
	LOOP
	MBR $170 16 SD DUMPL
	;



{
MS FORMULA
RootDirSectors = ((BPB_RootEntCnt * 32) + (BPB_BytsPerSec – 1)) / BPB_BytsPerSec;
TmpVal1 = DskSize – (BPB_ResvdSecCnt + RootDirSectors);
TmpVal2 = (256 * BPB_SecPerClus) + BPB_NumFATs;
TmpVal2 = TmpVal2 / 2;
FATSz = (TMPVal1 + (TmpVal2 – 1)) / TmpVal2;
    BPB_FATSz16 = 0;
    BPB_FATSz32 = FATSz;
}

--- assign cluster size for format ---
pri CLSZ ( bytes -- )
	DUP 0= IF DROP FATSZ 10 >> THEN
---	limit 512..64k      binary multiple scaled
	512 MAX 64KB MIN    >| |< 9>>  >!
pri #s/c
	128 --- 64KB MAX DEFAULT
	;

{
000_2001 SECTOR
0001_0000: 52 52 61 41  00 00 00 00  00 00 00 00  00 00 00 00     'RRaA............'

0001_01E0: 00 00 00 00  72 72 41 61  1D BA 0E 00  02 00 00 00     '....rrAa........'
0001_01F0: 00 00 00 00  00 00 00 00  00 00 00 00  00 00 55 AA     '..............U.'

Offset 	Description 	Size
00h 	First Signature (52h 52h 61h41h) 	1 Double Word
04h 	Unknown, Currently (Mightjust be Null) 	480 Bytes
1E4h 	Signature of FSInfo Sector(72h 72h 41h 61h) 	1 Double Word
1E8h 	Number of Free Clusters (Setto -1 if Unknown) 	1 Double Word
1ECh 	Cluster Number of Clusterthat was Most Recently Allocated. 	1 Double Word
1F0h 	Reserved 	12 Bytes
1FCh 	Unknown or Null 	2 Bytes
1FEh 	Boot Record Signature (55hAAh) 	2 Bytes
}



pri !FSINFO
	!SDBUF
	" RRaA" SDBUF $!
	" rrAa" $1E4 SDBUF+ $!
	-1 $1E8 SDBUF+ !
	2 $1EC SDBUF+ !
	$AA55 $1FE SDBUF+ W!
---	update file information sector
	SDBUF @BOOT 1+ SDWR
	;

pri !FATX
	!SDBUF
	$0FFF_FFF8 DUP 0 SDBUF+ ! 8 SDBUF+ !
\	$0FFF_FFFF 4 SDBUF+ !
	-1 4 SDBUF+ !
	RW s/f @ ADO SDBUF I SDWR !SDBUF SPINNER LOOP
	;

pub !FATS
	fat1 @ !FATX
	fat2 @ !FATX
	;

pub FORMAT.FAT
	fat32 fatsz ERASE
---	jump code (redundant?)
	$905BEB fat32 !
---	name of formatting system
	" TAQOZ P2" oemname $!
	512 b/s W!
	#s/c 0= IF 0 CLSZ THEN #s/c s/c C!
---	RESERVED ??? check
\	#s/c 8 + rsvd W!	( should this be set to a constant 32? )
	32 rsvd W!
	2 fats C!
	$F8 media C!
	@BOOT hidden !

---	sectors/track
\	#s/c media 3 + W!
	$3F media 3 + W!
---	number of heads
\	#s/c 2* media 5 + W!
	$FF media 5 + W!
---	sectors/partition = sectors/sd - hidden
	FATSZ DUP s/p !

---	calculate sectors/fat +  fudge

	sdsize @ @BOOT - #s/c >| 7 + >> ( #s/c 2/ +  )    s/f !
\	#s/c >| 7 + >>          #s/c 2/ +     s/f !
	0 fat? !		--- clear fat flags and fatver (4 bytes)
	2 rootcl !
	1 rootcl 4+ W!		--- partition info sector
	6 bbsect W!		--- backup boot sector
	128 ldn W!		--- logical drive#
	$29 extsig C!
	RND serial !
---	 Volumne name FAT name
	" P2 CARD    FAT32   " volname 19 CMOVE
---
	@BOOT rsvd W@ + DUP fat1 !  s/f @ + fat2 !
---	update buffer with our copy of FAT
	!SDBUF fat32 SDBUF 96 CMOVE
	$AA55 $1FE SDBUF+ W!
---	write FAT32 boot sector
	SDBUF @BOOT SDWR
---	write backup boot sector
	SDBUF @BOOT 6 + SDWR
---	then info sector
	!FSINFO
---	and init and zero all the FAT entries (takes a while)
	!FATS
	;

pri .res	" res" .LINE  ;
pri .PS		SWAP .LINE rootcl + W@ DUP .W ."  = " @BOOT + .L ;

{
	byte	fats		--- 02
2	res	Maximum Root DirectoryEntries (non-FAT32)
2	res	Number of Sectors inPartition Smaller than 32MB (non-FAT32)
	byte	media		--- F8 hard disk
2	res	Sectors Per FAT in Older FATSystems (N/A for FAT32)
2	res	Sectors Per Track --- 3F 00
2	res	Number of Heads	--- FF 00
	long	hidden	Number of Hidden Sectors inPartition --- 00 20 00 00
}


pub .FAT --- print FAT32 BOOT RECORD
	parts 4 + C@ ?FS 0= " FORMAT" ?ERROR
	  " FAT32" .TITLE
	  " OEM" .LINE oemname 8 CTYPE
	  " Byte/Sect" .LINE b/s W@ DUP PRINT
	  " Sect/Clust" .LINE s/c C@ DUP PRINT ."  = " * ( 1000 * ) .MEM
\	  .res s/c 1+ 2 .BYTES
	  " FATs" .LINE fats C@ PRINT
\	  .res fats 1+ 4 .BYTES
	  " Media" .LINE media C@ .BYTE
\	  .res media 1+ 2 .BYTES
	  " Sect/Track" .LINE media 3 + W@ .
	  " Heads" .LINE media 5 + W@ .
	  " Hidden Sectors" .LINE hidden .MBS
	  " Sect/Part" .LINE s/p .MBS
	  " Sect/FAT" .LINE s/f .MBS
	  " Flags"  .LINE 8 fat? SET? IF ." Mirroring to" THEN fat? C@ >N PRINT
	  " Ver" .LINE fat? 2+ 2 .BYTES
	  " ROOT Cluster" .LINE rootcl @ .L ."  SECTOR: " rootdir @ .L
	  " INFO Sector"  4 .PS
	  " Backup Sector"  6 .PS
	  .res rootcl 8 + 12 .BYTES
	  " Drive#"  .LINE ldn C@ PRINT --- Should be 0 or 128
	  " Ext sig" .LINE extsig C@ DUP .B $29 = .OK
	  " Part Serial#" .LINE serial @ DUP .L ."  #" U.
	  " Volume Name" .LINE volname 19 CTYPE
	\  " FAT Name" .LINE  volname 11 + 8 CTYPE
	;


{
                  *** FAT32 ***
    OEM............................. mkfs.fat
    Byte/Sect....................... 512
    Sect/Clust...................... 8 = 4kB
    FATs............................ 2
    MEDIA........................... F8
    Sect/Track...................... $003E
    Heads........................... $007A
    Hidden Sectors.................. 8192
    Sect/Part....................... 7,736,320 = 3,960MB
    Sect/FAT........................ 7,544
    FLAGS........................... 0
    VERSION......................... 00 00
    ROOT Cluster.................... $0000_0002 SECTOR: $0000_5B10
    INFO Sector..................... $0001 = $0000_2001
    BACKUP Sector................... $0006 = $0000_2006
    res............................. 00 00 00 00 00 00 00 00 00 00 00 00
    Drive#.......................... 384
    Ext sig......................... $29 OK!
    Part Serial#.................... $7806_E39C 2013717404
    Volume Name..................... TEST
    FAT Name........................ FAT32    ok
TAQOZ#
}

pub .FREE
	?FREE
	" FREE" .line freecl @ s/c C@ * .MB
\ pub .USED
	" USED" .LINE usedcl @ s/c C@ * .MB
\ pub .USED%
	used% @ .AS"  (##.##%) "
	;


pub .DISK	MOUNT .SD  .MBR .FAT ;

--- erase root directory cluster
pub FORMAT.ROOT
	!SDBUF RW
---	populate with a single volume entry
	" ROOTDIR    " SDBUF $! 8 11 SDBUF+ C!
---	write out sectors with remaining blank
	@ROOT s/c C@ ADO SDBUF I SDWR !SDBUF LOOP
	;


{ 	FORMAT
Use xx CLSZ beforehand to set non-default cluster size
Use RWS to set system permissions etc
USAGE: 32 KB CLSZ RWS FORMAT
}
pub FORMAT
	wrens C@ 7 = SD? AND
	IF
	  FORMAT.MBR
	  FORMAT.FAT
	  GETFAT
 	  FORMAT.ROOT
	  MOUNT .DISK
 	ELSE
	  ."  FAILED!"
	THEN
	0 CLSZ	--- reset default cluster size
	;






	--- Old style Forth disk block ---

pub .BLOCK ( blk# -- )
	CRLF ." BLOCK " DUP .
	10 << $400 ADO I $3F AND 0= IF CRLF THEN
	  I SDC@ DUP $20 $7E WITHIN 0= IF DROP '.' THEN EMIT
	  LOOP
	;

long bn
pri .EDIT	CLS PRINT" FILE: " file$ PRINT$ ;
pri VK
	KEY a>A SWITCH
	',' CASE -1 bn +! TRUE BREAK
	'.' CASE 1 bn +! TRUE BREAK
	'<' CASE -10 bn +! TRUE BREAK
	'>' CASE 10 bn +! TRUE BREAK
	$1B CASE R> DROP BREAK
	'H' CASE CLS .EDIT bn @ 10 << $400 SD DUMP FALSE BREAK
	$0D CASE bn ! 0 TRUE BREAK
	$08 CASE DROP 0 FALSE BREAK
 	CASE@ '0' '9' WITHIN IF 10 * CASE@ '0' - + CR DUP . 8 SPACES FALSE BREAK
	FALSE
	;

pub EDITBLOCK ( blk -- )
	bn ! 0 BEGIN
	  .EDIT
	  bn @ DUP .BLOCK 1+ .BLOCK CRLF DUP . 8 SPACES
	  BEGIN VK UNTIL
	AGAIN
	;


pub LISTBLOCKS
	0 BEGIN DUP SDC@ KEY 0= AND
	WHILE
	DUP .BLOCK 1+
	REPEAT
	DROP
	;



{
RAW BOOT SECTOR INFO
MBR:
$17C	= "ProP"
$174	= SECTOR
$178	= BYTES

RW " ProP"  @ $17C SD! 1 $174 SD! 65536 $178 SD! FLUSH

}

pri BIX					" _BOOT_P2.BIX" ;

--- Set the MBR boot signature and timestamp as 2021/01/21 WED 22:44:34
pri SIG! ( sig -- ) 	FCLOSE RWS  MBR $17C SD! $150 FSEND! PRINT" BOOT: " .FDT EMIT; ;

pri BU!					RW 0 @FILE $2.0000 RW SDWRS RO @FILE @ROOT > IF MODIFIED THEN   SDWR? .SUCCESS ;

--- Backup to filename or FLASH : options: DISABLE, FLASH, MBR, BIX
pre BACKUP
	GET$
pub BACKUP$ ( " MBR" BACKUP$ )
	VEC0 0 !	--- boot image needs this jmp vector intact - restore it just in case
	DUP UPPER$
	DUP " DISABLE" $= IF DROP 0 SIG! FLUSH ( BIX FOPEN$ @FILE IF RENAME THEN ) EXIT; THEN
	DUP " FLASH" $= IF DROP SFJID 1+ IF SFBU THEN SFJID 1+ .SUCCESS BREAK
	MOUNTED?
	IF
	DUP " MBR" $=
---	    Create MBR signature and          point to sector 1 as 64k file       then open sector 1
	  IF --- backup to MBR      start       bytes
	    DROP " ProP" @ SIG!	    1 $174 SD! $2.0000 $178 SD! FCLOSE
---	    Use sector 1 in the hidden partition for the file
	    1 OPEN-SECTOR BU! EXIT
---	    else open the specified filename
	  ELSE
		DUP " BIX" $= IF DROP BIX 128 KB MAKE THEN
	    FOPEN$
	  THEN
---	backup to file
	  IF BU! BREAK
	THEN
	0 .SUCCESS
	;

--- BACKUP to SD MBR shortcut
pub BU		MOUNT " MBR" BACKUP$ ;
pri ~B		BU CRLF PROMPT ;	AT ~B ^B CTRL!


---	SD
pub ?SD
	SD? IF CRLF+ PRINT" SD CARD"
	2 TABS sdsize @ 512 1,000,000,000 */ . PRINT" GB  "
	.CARD THEN
	;

' ?SD  +DEVICE


AT REBOOT ^Z CTRL!

--- perform SYSINFO one second after powerup (allows for USB connection etc)
\ pub MAIN	FORTH 500 ms KEY 1 <> 0EXIT I2C.START 1 ms I2C.STOP RDRTC MOUNT DISCARD   SYSINFO ;
--- ( note - the initial 500 ms delay is necessary to prevent garbling on the UB3 serial )
pub MAIN
	FORTH 5 ms ." BOOTING.... " 5 ms KEY 1 <> 0EXIT
	I2C.START 1 ms I2C.STOP RDRTC
	GETMS rtcms !
	$1F RTC@ 1+ $1F RTC!
	MOUNT DISCARD
	SYSINFO
	;

AUTO MAIN
\ RECLAIM


END
