IFDEF *P2ASM*	FORGET *P2ASM* }
TAQOZ

pub *P2ASM*	PRINT" TAQOZ INTERACTIVE ASSEMBLER for the PARALLAX P2 - 200713-1000" ;


ALIAS pri #define


public

 	*** fixed data registers ***
AT + COG@ 9 BITS	:= tos
tos					:= a
tos 1+				:= b
tos 2+				:= c
tos 3 +				:= d

( TAQOZ temporary registers )
AT = 1+ COG@ 9 BITS	:= xx
xx 1+				:= yy
xx 2+				:= zz
yy					:= r0
zz					:= r1

r1 1+				:= r2
r2 1+				:= r3
r3 1+				:= r4
xx 1-				:= acc
acc					:= ac

( more kernel registers )
23					:= _depth
24					:= _pin

02					:= sck
03					:= mosi
04					:= miso
05					:= ss
06					:= reg4
07					:= reg5
08					:= reg6



private
byte warnings
pri WARN			warnings C++ ;




	*** CZ CONDITIONAL OPERATORS ***

byte cc	--- condition code (normally %1111 = always)

pub _ret_			0
pri cc! 			cc C! ;

public
: if_nz_and_nc  : if_a  : if_00  : if_nc_and_nz
: {nc&nz}		1 cc! ;


: if_z_and_nc  : if_01  : if_nc_and_z
: {nc&z}		2 cc! ;

: if_ae  : if_0x  : if_nc
: {nc}			3 cc! ;

: if_nz_and_c  : if_10  : if_c_and_nz
: {c&nz}		4 cc! ;

: if_ne  : if_x0  : if_nz
: {nz}			5 cc! ;

: if_z_ne_c  : if_diff  : if_c_ne_z
: {c<>z}		6 cc! ;

: if_nz_or_nc  : if_not_11  : if_nc_or_nz
: {nc|nz}		7 cc! ;

: if_11  : if_z_and_c  : if_c_and_z
: {c&z}			8 cc! ;

: if_same  : if_z_eq_c  : if_c_eq_z
: {c=z}			9 cc! ;

: if_e  : if_x1  : if_z
: {z}			10 cc! ;

: if_z_or_nc  : if_not_10  : if_nc_or_z
: {nc|z}		11 cc! ;

: if_b  : if_1x  : if_c
: {c}			12 cc! ;

: if_not_01  : if_nz_or_c  : if_c_or_nz
: {c|nz}		13 cc! ;

: if_not_00  : if_be  : if_z_or_c  : if_c_or_z
: {c|z}			14 cc! ;


private
byte _cdepth
byte _adepth --- depth of stack at start of line
pri ADEPTH ( -- depth )		DEPTH _adepth C@ - ;


( CONDITION CODE EFFECTS  CZI )
byte eff
pri eff!		eff SET ;
pri eff@		eff C@ ;

	*** with condition code operators ***

pub wc			4 eff! ;
pub wz			2 eff! ;
pub wcz			6 eff! ;


--- Use of the first # in source will always use the #s immediate, a comma will force this over to #d (L)
pub #s			ADEPTH 2 < IF 1 eff! THEN ;
pub #d			2 eff! ;
pri no#			3 eff CLR ;


pri ?EFF		eff@ AND IF PRINT"  !effects not allowed! " WARN THEN ;
pri -CZI		7 ?EFF ;
pri -CZ			6 ?EFF ;
pri -I			1 ?EFF ;

byte aflgs
	1	:= -abs
	2	:= -noaug

pri abs?		-abs aflgs SET? ;
pub aa			-abs aflgs SET ;
pri noaug		-noaug aflgs CLR ;


long _pc

pri PC			_pc @ ;


{
PTRx expressions without AUGS:

    INDEX6 = -32..+31 for non-updating offsets
    INDEX = 0..16 for ++'s and --'s
    SCALE = 1 for RDBYTE/WRBYTE, 2 for RDWORD/WRWORD, 4 for RDLONG/WRLONG/WMLONG

    S = 0 for PTRA, 1 for PTRB
    U = 0 to keep PTRx same, 1 to update PTRx (PTRx += INDEX*SCALE)
    P = 0 to use PTRx + INDEX*SCALE, 1 to use PTRx (post-modify)
    IIIIII = INDEX6, uses %100000..%111111 for -32..-1 and %000000..%011111 for 0..31
    NNNNN = INDEX, uses %00001..%01111 for 1..15 and %00000 for 16
    nnnnn = -INDEX, uses %10000..%11111 for -16..-1

    1SUPNNNNN     PTR expression
    ------------------------------------------------------------------------------
    100000000     PTRA              'use PTRA
    110000000     PTRB              'use PTRB
    100IIIIII     PTRA[INDEX6]      'use PTRA + INDEX6*SCALE
    110IIIIII     PTRB[INDEX6]      'use PTRB + INDEX6*SCALE

    101100001     PTRA++            'use PTRA,                PTRA += SCALE
    111100001     PTRB++            'use PTRB,                PTRB += SCALE
    101111111     PTRA--            'use PTRA,                PTRA -= SCALE
    111111111     PTRB--            'use PTRB,                PTRB -= SCALE
    101000001     ++PTRA            'use PTRA + SCALE,        PTRA += SCALE
    111000001     ++PTRB            'use PTRB + SCALE,        PTRB += SCALE
    101011111     --PTRA            'use PTRA - SCALE,        PTRA -= SCALE
    111011111     --PTRB            'use PTRB - SCALE,        PTRB -= SCALE

    1011NNNNN     PTRA++[INDEX]     'use PTRA,                PTRA += INDEX*SCALE
    1111NNNNN     PTRB++[INDEX]     'use PTRB,                PTRB += INDEX*SCALE
    1011nnnnn     PTRA--[INDEX]     'use PTRA,                PTRA -= INDEX*SCALE
    1111nnnnn     PTRB--[INDEX]     'use PTRB,                PTRB -= INDEX*SCALE
    1010NNNNN     ++PTRA[INDEX]     'use PTRA + INDEX*SCALE,  PTRA += INDEX*SCALE
    1110NNNNN     ++PTRB[INDEX]     'use PTRB + INDEX*SCALE,  PTRB += INDEX*SCALE
    1010nnnnn     --PTRA[INDEX]     'use PTRA - INDEX*SCALE,  PTRA -= INDEX*SCALE
    1110nnnnn     --PTRB[INDEX]     'use PTRB - INDEX*SCALE,  PTRB -= INDEX*SCALE
}

--- To use PTR expression, use the lowercase version. Uppercase is simply the cog address
pub ptra							#s %100000000 ;
pub ptrb							#s %110000000 ;
pub ptra++							#s %101100001 ;
pub ptrb++							#s %111100001 ;
pub ptra--							#s %101111111 ;
pub ptrb--							#s %111111111 ;
pub ++ptra							#s %101000001 ;
pub ++ptrb							#s %111000001 ;
pub --ptra							#s %101011111 ;
pub --ptrb							#s %111011111 ;



	*** condition codes ***

pri +cc								cc C@ 10 << OR ;
--- merge in condition codes and shift into position
pri +ops							+cc 18 << OR ;
pri +d								SWAP 9 << OR ;

	*** EFFECTS  ***

--- czi effects added into opcode (tos)
pri +E ( op -- op+eff )				eff@ AND OR ;

pri +C								4 +E ;
pri +Z								2 +E ;
pri +I								1 +E ;
pri +CZ								eff@ 6 = IF 6 +E THEN ;


	*** LISTING ***

\ setbyte d,s,#n	setbyte d,#s,#n
\ handle comma in source as a delimiter and handle precedence of immediate #
---			#d,#s  or d,#s,#n  or  d,s,#n
pub ,,								ADEPTH 1 = IF 0 +I IF 1 eff CLR #d THEN THEN ;

{

Listing format 4:7:3:9:9
F600_1A0B
F 30 0 0D 0B
}

byte _l --- list control flag
pri ?CRLF							_l C@ 0EXIT CRLF ;
pri ?EMIT							_l C@ IF EMIT ELSE DROP THEN ;
pri INDENT							CRLF _l C@ 0EXIT 16 SPACES ;
pri .ASM							_l C@ IF CR PC DUP 16>> .H .WORD pRINT"  " .LONG ELSE DROP THEN ;
pri ASM,	 						DUP .ASM PC ! 4 _pc +! ;


--- check D & S for range and augment if necessary
pri ?AUG ( d s op -- d s* op )
	abs? -noaug aflgs SET? OR ?EXIT
	SWAP L>S ?DUP IF $FF_000000 + ASM, ?CRLF THEN SWAP
	ROT L>S ?DUP IF $FF_800000 + ASM, ?CRLF THEN -ROT
	;

	*** BLENDER ***

--- dest source plus CZI routines
pri DSCZI ( d s op -- )				+C
pri DSZI							+Z
pri DSI ( d s op )					+I
pri DSOP ( d s op )					?AUG +ops +d ASM, ;
pri DSCZ ( d s op )					+C +Z DSOP ;
pri DSCI							+I
pri DSC								+C +ops +d ASM, ;

	*** INSTRUCTIONS ***

	*** LOGIC ***

--- ( d # s ) {WC/WZ/WCZ}
pub and ->		 					%0101000_000 DSCZI ;
pub andn -> 		 				%0101001_000 DSCZI ;
pub or -> 		 					%0101010_000 DSCZI ;
pub xor -> 		 					%0101011_000 DSCZI ;
pub muxc -> 		 				%0101100_000 DSCZI ;
pub muxnc -> 		 				%0101101_000 DSCZI ;
pub muxz -> 		 				%0101110_000 DSCZI ;
pub muxnz -> 		 				%0101111_000 DSCZI ;
pub mov -> 		  					%0110000_000 DSCZI ;
pub not -> 		  					%0110001_000 DSCZI ;
pub abs -> 		  					%0110010_000 DSCZI ;
pub neg -> 		  					%0110011_000 DSCZI ;
pub negc -> 		  				%0110100_000 DSCZI ;
pub negnc -> 		  				%0110101_000 DSCZI ;
pub negz -> 		  				%0110110_000 DSCZI ;
pub negnz -> 		  				%0110111_000 DSCZI ;
pub test -> 		  				%0111110_000 DSCZI ;
pub testn -> 		  				%0111111_000 DSCZI ;
pub zerox -> 		  				%0111010_000 DSCZI ;
pub signx -> 		  				%0111011_000 DSCZI ;
pub encod -> 		  				%0111100_000 DSCZI ;
pub ones -> 		  				%0111101_000 DSCZI ;

	*** SHIFT ***

pub ror -> 		 					%0000000_000 DSCZI ;
pub rol -> 		 					%0000001_000 DSCZI ;
pub shr -> 		 					%0000010_000 DSCZI ;
pub shl -> 		 					%0000011_000 DSCZI ;
pub rcr -> 		 					%0000100_000 DSCZI ;
pub rcl -> 		 					%0000101_000 DSCZI ;
pub sar -> 		 					%0000110_000 DSCZI ;
pub sal -> 		 					%0000111_000 DSCZI ;

	*** ARITHMETIC ***

pub add -> 		 					%0001000_000 DSCZI ;
pub addx -> 		 				%0001001_000 DSCZI ;
pub adds -> 		 				%0001010_000 DSCZI ;
pub addx -> 		 				%0001011_000 DSCZI ;
pub sub -> 		 					%0001100_000 DSCZI ;
pub subx -> 		 				%0001101_000 DSCZI ;
pub subs -> 		 				%0001110_000 DSCZI ;
pub subsx -> 		 				%0001111_000 DSCZI ;
pub subr -> 		 				%0010110_000 DSCZI ;
pub cmpsub -> 		 				%0010111_000 DSCZI ;
pub sumc -> 		 				%0011100_000 DSCZI ;
pub sumnc -> 		 				%0011101_000 DSCZI ;
pub sumz -> 		 				%0011110_000 DSCZI ;
pub sumnz -> 		 				%0011111_000 DSCZI ;
pub incmod -> 		 				%0111000_000 DSCZI ;
pub decmod -> 		 				%0111001_000 DSCZI ;
pub mul -> 		 					%1010000_000 DSZI ;
pub muls -> 		 				%1010000_100 DSZI ;
pub sca -> 		 					%1010001_000 DSZI ;
pub scas -> 		 				%1010001_100 DSZI ;
--- Pseudo instructions
pub dec ->					#s 1 	%0001100_000 DSCZI ;
pub inc	->					#s 1 	%0001000_000 DSCZI ;

	*** COMPARE ***

pub cmp -> 		  					%0010000_000 DSCZI ;
pub cmpx -> 		  				%0010001_000 DSCZI ;
pub cmps -> 		  				%0010010_000 DSCZI ;
pub cmpsx -> 		  				%0010011_000 DSCZI ;
pub cmpr -> 		  				%0010100_000 DSCZI ;
pub cmpm -> 		  				%0010101_000 DSCZI ;

	*** MINMAX **

pub fge -> 		  					%0011000_000 DSCZI ;
pub fle -> 		  					%0011001_000 DSCZI ;
pub fges -> 		  				%0011010_000 DSCZI ;
pub fles -> 		  				%0011011_000 DSCZI ;

	*** BIT ***

--- these instructions write to C or Z - WC/WZ - ANDC/ANDZ - ORC/ORZ - XORC/XORZ
pub testb -> 	( d s -- ) 			%0100000_000 DSCZI ;
pub testbn -> 	( d s -- ) 			%0100001_000 DSCZI ;

--- modify TESTBx and TESTPx instructions
pub andc							%010_100 eff! ;
pub andz							%010_010 eff! ;
pub orc								%100_100 eff! ;
pub orz								%100_010 eff! ;
pub xorc							%110_100 eff! ;
pub xorz							%110_010 eff! ;


--- specify no effects or WCZ only
pub bitl -> 	( d s ) 			%0100000_000 DSCZI ;
pub bith -> 	( d s ) 			%0100001_000 DSCZI ;
pub bitc -> 	( d s ) 			%0100010_000 DSCZI ;
pub bitnc -> 	( d s ) 			%0100011_000 DSCZI ;
pub bitz -> 	( d s ) 			%0100100_000 DSCZI ;
pub bitnz -> 	( d s ) 			%0100101_000 DSCZI ;
pub bitrnd -> 	( d s ) 			%0100110_000 DSCZI ;
pub bitnot -> 	( d s ) 			%0100111_000 DSCZI ;

pri DSNIB ( d s #n op max )
	ADEPTH 1 = IF 0 SWAP 0 THEN 	--- fill in D and N
	3RD < IF PRINT"  range exceeded " THEN
	SWAP 2* OR +I DSOP
	;

--- NOTE - ALTSN version can override d and #n
pub setnib -> 	( d # s #n  ) 		%100000_000_0 7 DSNIB ;
pub getnib -> 	( d # s #n  ) 		%100001_000_0 7 DSNIB ;
pub rolnib -> 	( d # s #n  ) 		%100010_000_0 7 DSNIB ;
pub setbyte -> 	( d # s #n  ) 		%100011_000_0 3 DSNIB ;
pub getbyte -> 	( d # s #n  ) 		%100011_100_0 3 DSNIB ;
pub rolbyte -> 	( d # s #n  ) 		%100100_000_0 3 DSNIB ;
pub setword -> 	( d # s #n  ) 		%100100_100_0 1 DSNIB ;
pub getword -> 	( d # s #n  ) 		%100100_110_0 1 DSNIB ;
pub rolword -> 	( d # s #n  ) 		%100101_000_0 1 DSNIB ;

pub setr -> 	( d # s )			%100110101_0 DSI ;
pub setd -> 	( d # s )			%100110110_0 DSI ;
pub sets -> 	( d # s )			%100110111_0 DSI ;
pub decod -> 	( d # s )			%100111000_0 DSI ;
pub bmask -> 	( d s )				%100111001_0 DSI ;
pub crcbit -> 	( d s )				%100111010_0 DSI ;
pub crcnib -> 	( d s )				%100111011_0 DSI ;
pub muxnits -> 	( d s )				%100111100_0 DSI ;
pub muxnibs -> 	( d s )				%100111101_0 DSI ;
pub muxq -> 	( d s )				%100111110_0 DSI ;
pub movbyts -> 	( d s )				%100111111_0 DSI ;

--- destination op
pri DOP ( d )						%1101011_000 DSOP ;
pub splitb -> 	( d )				%001100000 DOP ;
pub mergeb -> 	( d )				%001100001 DOP ;
pub splitw -> 	( d )				%001100010 DOP ;
pub mergew -> 	( d )				%001100011 DOP ;
pub seussf -> 	( d )				%001100100 DOP ;
pub seussr -> 	( d )				%001100101 DOP ;
pub xoro32 -> 	( d )				%001101000 DOP ;
pub rev -> 	( d )					%001101001 DOP ;
pub wrc -> 	( d )					%001101100 DOP ;
pub wrnc -> 	( d )				%001101101 DOP ;
pub wrz -> 	( d )					%001101110 DOP ;
pub wrnz -> 	( d )				%001101111 DOP ;




--- {WC WZ WCZ}
pub rczr -> 	( d )				%001101010 %1101011_000 DSCZ ;
pub rczl -> 	( d )				%001101011 %1101011_000 DSCZ ;

{
pub MODCZ ( d -- )	%001101011 DCZ ;
pub MOVC
pub MODZ

}


	*** ALTER ***

pri DSIA                      		ADEPTH 1 = 0 +I 0= AND IF 0 #s THEN DSI ;
pub altsn -> 	( D # S )			%1001010100	DSIA ;
pub altgn -> 	( D # S )			%1001010110	DSIA ;
pub altsb -> 	( D # S )			%1001011000	DSIA ;
pub altgb -> 	( D # S )			%1001011010	DSIA ;
pub altsw -> 	( D # S )			%1001011100	DSIA ;
pub altgw -> 	( D # S )			%1001011110	DSIA ;
pub altr -> 	( D # S )			%1001100000	DSIA ;
pub altd -> 	( D # S )			%1001100010	DSIA ;
pub alts -> 	( D # S )			%1001100100	DSIA ;
pub altb -> 	( D # S )			%1001100110	DSIA ;
pub alti -> 	( D # S )			%1001101000	DSIA ;

pub augs -> 	( N )	        	23 BITS %11110_00000 +ops ASM, ;
pub augd -> 	( N )	        	23 BITS %11111_00000 +ops ASM, ;

	*** HUB RAM ***
{
0c67af1f 	_ret_	wrlong	z,ptra[-1]
fb07ab5f 		rdlong	x,--ptra
fc679f61 		wrlong	v,ptra++
}

pub wmlong -> 	( d s/p -- )		%101001111_0 DSI ;
pub rdbyte -> 	( d s/p -- )		%1010110_000 DSCZI ;
pub rdword -> 	( d s/p -- )		%1010111_000 DSCZI ;
pub rdlong -> 	( d s/p -- )		%1011000_000 DSCZI ;
pub popa -> 	( d -- )			%101011111 #s %1011000_000 DSCZI ;
pub popb -> 	( d -- )			%111011111 #s %1011000_000 DSCZI ;

--- allow #d as well as #s   ( d # s # WRBYTE )
pub DSLI						+Z +I DSOP ;

pub wrbyte -> 		 ( d s/p -- )	%11000100_00 DSLI ;
pub wrword -> 		 ( d s/p -- )	%11000101_00 DSLI ;
pub wrlong -> 		 ( d s/p -- )	%11000110_00 DSLI ;

	*** FAST HUB ***

pub rdfast -> 	( # D # S )			%1100011_100 DSLI ;
pub wrfast -> 	( # D # S )			%1100100_000 DSLI ;
pub fblock -> 	( # D # S )			%1100100_100 DSLI ;

pub rfbyte -> 	( D ) { WC/WZ/WCZ }	%000010000 	%1101011_000 DSCZ ;
pub rfword -> 	( D ) { WC/WZ/WCZ }	%000010001 	%1101011_000 DSCZ ;
pub rflong -> 	( D ) { WC/WZ/WCZ }	%000010010 	%1101011_000 DSCZ ;
pub rfvar -> 	( D ) { WC/WZ/WCZ }	%000010011 	%1101011_000 DSCZ ;
pub rfvars -> 	( D ) { WC/WZ/WCZ }	%000010100 	%1101011_000 DSCZ ;
pub wfbyte -> 	( # D )  			%000010101 	%1101011_000 DSI ;
pub wfword -> 	( # D )  			%000010110 	%1101011_000 DSI ;
pub wflong -> 	( # D )  			%000010111 	%1101011_000 DSI ;
pub getptr -> 	( D )				%000110100 	%1101011_000 DSOP ;


	*** BRANCH ***


pub rep -> 	( ins times -- )		%11001101_00 DSLI ;
pri REL9 ( to -- rel )				0 +I IF PC 4+ - 4/ THEN 9 BITS ;
 --- If #S and cogex, PC += signed(S). If #S and hubex, PC += signed(S*4). If S, PC = register S.

pub djz -> 	( d # s )				REL9 %101101100_0 DSI ;
pub djnz -> 	( d # s )			REL9 %101101101_0 DSI ;
pub djf -> 	( d # s )				REL9 %101101110_0 DSI ;
pub djnf -> 	( d # s )			REL9 %101101111_0 DSI ;
pub ijz -> 	( d # s )				REL9 %101110000_0 DSI ;
pub ijnz -> 	( d # s )			REL9 %101110001_0 DSI ;
pub tjz -> 	( d # s )				REL9 %101110010_0 DSI ;
pub tjnz -> 	( d # s )			REL9 %101110011_0 DSI ;
pub tjf -> 	( d # s )				REL9 %101110100_0 DSI ;
pub tjnf -> 	( d # s )			REL9 %101110101_0 DSI ;
pub tjs -> 	( d # s )				REL9 %101110110_0 DSI ;
pub tjns -> 	( d # s )			REL9 %101110111_0 DSI ;
pub tjv -> 	( d # s )				REL9 %101111000_0 DSI ;
pub callpa -> 	( #d s -- )			%10110100_00 DSLI ;
pub callpb -> 	( #d s -- )			%10110101_00 DSLI ;

pri REL20							PC 4+ - 20 BITS noaug ;
pri ABS20							noaug ;


( op\ is temporary method for selecting abs vs rel 20-bit addr )
pub JMPR, ( addr )					REL20 %1101100_1_00 +ops ASM, ;
pub JMP\, ( addr )					ABS20 %1101100_0_00 +ops ASM, ;
pub CALLR, ( addr )					REL20 %1101101_1_00 +ops ASM, ;
pub CALL\, ( addr )					ABS20 %1101101_0_00 +ops ASM, ;

pub CALLAR, ( addr )				REL20 %1101110_1_00 +ops ASM, ;
pub CALLA\, ( addr )				ABS20 %1101110_0_00 +ops ASM, ;
pub CALLBR, ( addr )				REL20 %1101111_1_00 +ops ASM, ;
pub CALLB\, ( addr )				ABS20 %1101111_0_00 +ops ASM, ;
--- calld	lr, #_PUTCW
pub CALLDS, ( d s )					%1011001_000 DSCZI ;

pri PR20							+ops ASM, ;
pub CALLDR, ( p addr )				SWAP PA - SWAP REL20 	%11100_00_1_00 PR20 ;
pub CALLD\, ( p addr )				SWAP PA - SWAP ABS20	%11100_00_0_00 PR20 ;

pub LOCR, ( p addr )				SWAP PA - SWAP REL20 	%11100_00_1_00 PR20 ;
pub LOC\, ( p addr )				SWAP PA - SWAP ABS20	%11101_00_0_00 PR20 ;


pri DSI0							%110101100_0 DSI ;

pub JMP-D, ( D )	{ WC/WZ/WCZ }		%000101100 	%1101011_000	DSCZ ;
pub CALL-D, ( D )	{ WC/WZ/WCZ }		%000101101 %1101011_000	DSCZ ;
pub ret				{ WC/WZ/WCZ }	0	%000101101 %1101011_001	DSCZ ;
pub CALLAD, ( D )	{ WC/WZ/WCZ }		%000101110 %1101011_000	DSCZ ;
pub reta			{ WC/WZ/WCZ }	0	%000101110 %1101011_001	DSCZ ;
pub CALLBD, ( D )	{ WC/WZ/WCZ }		%000101111 %1101011_000	DSCZ ;
pub retb			{ WC/WZ/WCZ }	0	%000101111 %1101011_001	DSCZ ;

pub jmprel -> ( # D )				%000110000 DSI0 ;
pub skip -> ( # D )					%000110001 DSI0 ;
pub skipf -> ( # D )				%000110010 DSI0 ;
pub execf -> ( # D )				%000110011 DSI0 ;

	*** INSTRUCTION MODE SELECTORS ***

pub jmp ->							no# eff@ IF JMP-D, ELSE abs? IF JMP\, ELSE JMPR, THEN THEN ;
pub call ->							no# eff@ IF CALL-D, ELSE abs? IF CALL\, ELSE CALLR, THEN THEN ;
pub calla ->						no# eff@ IF CALLAD, ELSE abs? IF CALLA\, ELSE CALLAR, THEN THEN ;
pub callb ->						no# eff@ IF CALLBD, ELSE abs? IF CALLB\, ELSE CALLBR, THEN THEN ;
pub calld ->						no# abs? IF CALLD\, ELSE CALLDR, THEN ;
pub loc ->							no# abs? IF LOC\, ELSE LOCR, THEN ;


	*** EVENTS ***

pri ROP         					%1011001110 DSOP ;
pub resi3 -> 						%111110000	%111110001 ROP ;
pub resi2 -> 						%111110010	%111110011 ROP ;
pub resi1 -> 						%111110100	%111110101 ROP ;
pub resi0 -> 						%111111110	%111111111 ROP ;
pub reti3 -> 						%111111111	%111110001 ROP ;
pub reti2 -> 						%111111111	%111110011 ROP ;
pub reti1 -> 						%111111111	%111110101 ROP ;
pub reti0 -> 						%111111111	%111111111 ROP ;

pri JOP     						SWAP %101111001_0 DSI ;
pub jint -> 	( # S )				%000000000 JOP ;
pub jct1 -> 	( # S )				%000000001 JOP ;
pub jct2 -> 	( # S )				%000000010 JOP ;
pub jct3 -> 	( # S )				%000000011 JOP ;
pub jse1 -> 	( # S )				%000000100 JOP ;
pub jse2 -> 	( # S )				%000000101 JOP ;
pub jse3 -> 	( # S )				%000000110 JOP ;
pub jse4 -> 	( # S )				%000000111 JOP ;
pub jpat -> 	( # S )				%000001000 JOP ;
pub jfbw -> 	( # S )				%000001001 JOP ;
pub jxmt -> 	( # S )				%000001010 JOP ;
pub jxfi -> 	( # S )				%000001011 JOP ;
pub jxro -> 	( # S )				%000001100 JOP ;
pub jxrl -> 	( # S )				%000001101 JOP ;
pub jatn -> 	( # S )				%000001110 JOP ;
pub jqmt -> 	( # S )				%000001111 JOP ;
pub jnint -> 	( # S )				%000010000 JOP ;
pub jnct1 -> 	( # S )				%000010001 JOP ;
pub jnct2 -> 	( # S )				%000010010 JOP ;
pub jnct3 -> 	( # S )				%000010011 JOP ;
pub jnse1 -> 	( # S )				%000010100 JOP ;
pub jnse2 -> 	( # S )				%000010101 JOP ;
pub jnse3 -> 	( # S )				%000010110 JOP ;
pub jnse4 -> 	( # S )				%000010111 JOP ;
pub jnpat -> 	( # S )				%000011000 JOP ;
pub jnfbw -> 	( # S )				%000011001 JOP ;
pub jnxmt -> 	( # S )				%000011010 JOP ;
pub jnxfi -> 	( # S )				%000011011 JOP ;
pub jnxro -> 	( # S )				%000011100 JOP ;
pub jnxrl -> 	( # S )				%000011101 JOP ;
pub jnatn -> 	( # S )				%000011110 JOP ;
pub jnqmt -> 	( # S )				%000011111 JOP ;

pub setpat -> 	( # D # S )			%1011111100 DSLI ;
pub addct1 -> 	( D # S )			%1010011000 DSI ;
pub addct2 -> 	( D # S )			%1010011010 DSI ;
pub addct3 -> 	( D # S )			%1010011100 DSI ;
pub setse1 -> 	( # D )				%000100000 %1101011000 DSI ;
pub setse2 -> 	( # D )				%000100001 %1101011000 DSI ;
pub setse3 -> 	( # D )				%000100010 %1101011000 DSI ;
pub setse4 -> 	( # D )				%000100011 %1101011000 DSI ;

pri CZOP        %1101011_00_0 +C +Z DSOP ;

pub pollint -> 	{ WC/WZ/WCZ }		%000000000	%000100100 CZOP ;
pub pollct1 -> 	{ WC/WZ/WCZ }		%000000001	%000100100 CZOP ;
pub pollct2 -> 	{ WC/WZ/WCZ }		%000000010	%000100100 CZOP ;
pub pollct3 -> 	{ WC/WZ/WCZ }		%000000011	%000100100 CZOP ;
pub pollse1 -> 	{ WC/WZ/WCZ }		%000000100	%000100100 CZOP ;
pub pollse2 -> 	{ WC/WZ/WCZ }		%000000101	%000100100 CZOP ;
pub pollse3 -> 	{ WC/WZ/WCZ }		%000000110	%000100100 CZOP ;
pub pollse4 -> 	{ WC/WZ/WCZ }		%000000111	%000100100 CZOP ;
pub pollpat -> 	{ WC/WZ/WCZ }		%000001000	%000100100 CZOP ;
pub pollfbw -> 	{ WC/WZ/WCZ }		%000001001	%000100100 CZOP ;
pub pollxmt -> 	{ WC/WZ/WCZ }		%000001010	%000100100 CZOP ;
pub pollxfi -> 	{ WC/WZ/WCZ }		%000001011	%000100100 CZOP ;
pub pollxro -> 	{ WC/WZ/WCZ }		%000001100	%000100100 CZOP ;
pub pollxrl -> 	{ WC/WZ/WCZ }		%000001101	%000100100 CZOP ;
pub pollatn -> 	{ WC/WZ/WCZ }		%000001110	%000100100 CZOP ;
pub pollqmt -> 	{ WC/WZ/WCZ }		%000001111	%000100100 CZOP ;
pub waitint -> 	{ WC/WZ/WCZ }		%000010000	%000100100 CZOP ;
pub waitct1 -> 	{ WC/WZ/WCZ }		%000010001	%000100100 CZOP ;
pub waitct2 -> 	{ WC/WZ/WCZ }		%000010010	%000100100 CZOP ;
pub waitct3 -> 	{ WC/WZ/WCZ }		%000010011	%000100100 CZOP ;
pub waitse1 -> 	{ WC/WZ/WCZ }		%000010100	%000100100 CZOP ;
pub waitse2 -> 	{ WC/WZ/WCZ }		%000010101	%000100100 CZOP ;
pub waitse3 -> 	{ WC/WZ/WCZ }		%000010110	%000100100 CZOP ;
pub waitse4 -> 	{ WC/WZ/WCZ }		%000010111	%000100100 CZOP ;
pub waitpat -> 	{ WC/WZ/WCZ }		%000011000	%000100100 CZOP ;
pub waitfbw -> 	{ WC/WZ/WCZ }		%000011001	%000100100 CZOP ;
pub waitxmt -> 	{ WC/WZ/WCZ }		%000011010	%000100100 CZOP ;
pub waitxfi -> 	{ WC/WZ/WCZ }		%000011011	%000100100 CZOP ;
pub waitxro -> 	{ WC/WZ/WCZ }		%000011100	%000100100 CZOP ;
pub waitxrl -> 	{ WC/WZ/WCZ }		%000011101	%000100100 CZOP ;
pub waitatn -> 	{ WC/WZ/WCZ }		%000011110	%000100100 CZOP ;

pub cogatn -> 	( # D )			%000111111 	DSI0 ;
pub hubset -> 	( # D )			%000000000 	DSI0 ;


	*** COG ***

pub coginit -> 	( # D # S ) { WC }	%1100111_000 +C DSLI ;
pub cogid -> 	( # D ) { WC }		%000000001 %1101011_000 DSCI ;
pub cogstop -> 	( # D )			%000000011 DSI0 ;
pub locknew -> 	( D ) { WC }		%000000100 %1101011_000 DSC ;
pub lockret -> 	( # D )			%000000101 DSI0 ;
pub locktry -> 	( # D ) { WC }		%000000110 %1101011_000 DSCI ;
pub lockrel -> 	( # D ) { WC }		%000000111 %1101011_000 DSCI ;

	*** STREAMER ***

pub xinit -> 	( # D # S )		%11001010_00 DSLI ;
pub xstop -> 	(  )			0 0 %1100101011 DSOP ;
pub xzero -> 	( # D #	S )		%11001011_00 DSLI ;
pub xcont -> 	( # D #	S )		%11001100_00 DSLI ;
pub setxfrq -> 	( # D )			%000011101 DSI0 ;
pub getxacc -> 	( D )			%000011110 %1101011000 DSOP ;

	*** CORDIC ***

pub qmul -> 	( # D #	S )		%11010000_00	DSLI ;
pub qdiv -> 	( # D # S )		%11010001_00	DSLI ;
pub qfrac -> 	( # D #	S )		%11010010_00	DSLI ;
pub qsqrt -> 	( # D #	S )		%11010011_00	DSLI ;
pub qrotate -> 	( # D #	S )		%11010100_00	DSLI ;
pub qvector -> 	( # D #	S )		%11010101_00	DSLI ;
pub qlog -> 	( # D )			%000001110 DSI0 ;
pub qexp -> 	( # D )			%000001111 DSI0 ;
pub getqx -> 	( D ) { WC/WZ/WCZ }	%000011000 %1101011_000 DSCZ ;
pub getqy -> 	( D ) { WC/WZ/WCZ }	%000011001 %1101011_000 DSCZ ;


	*** INTERRUPTS ***

pri INTX				-CZI
pri INT,                                %1101011_000 DSCZI ;

pub allowi -> 			 	%000100000	%000100100 INTX ;
pub stalli -> 			 	%000100001	%000100100 INTX ;
pub trgint1 -> 			 	%000100010	%000100100 INTX ;
pub trgint2 -> 			 	%000100011	%000100100 INTX ;
pub trgint3 -> 			 	%000100100	%000100100 INTX ;
pub nixint1 -> 			 	%000100101	%000100100 INTX ;
pub nixint2 -> 			 	%000100110	%000100100 INTX ;
pub nixint3 -> 			 	%000100111	%000100100 INTX ;

pub setint1 -> 	( # D )			%000100101 -CZ INT, ;
pub setint2 -> 	( # D )			%000100110 -CZ INT, ;
pub setint3 -> 	( # D )			%000100111 -CZ INT, ;
pub getbrk -> 	( D )	( WC/WZ/WCZ )	%000110101 -I INT, ;
pub cogbrk -> 	( # D )			%000110101 -CZ INT, ;
pub brk -> 	( # D )			%000110110 -CZ INT, ;


	*** INPUTS ***

*** TESTPx			blend in logicAL effects, clear,   opcode
pri TESTPX         		eff@ 3 >> OR ( s )  $F8 eff CLR %1101011_000 DSCZI ;

--- WC/WZ ANDC/ANZ ORC/ORZ XORC/XORZ
pub testp -> 	( # D ) 		%001000000 TESTPx ;
pub testpn -> 	( # D ) 		%001000001 TESTPx ;

	*** OUTPUTS ***

--- NNNNDDDDD
pri DCZ					%1101011_000 DSCZI ;

pub dirl -> 	( # D ) { WCZ } 	%001000000 DCZ ;
pub dirh -> 	( # D ) { WCZ } 	%001000001 DCZ ;
pub dirc -> 	( # D ) { WCZ } 	%001000010 DCZ ;
pub dirnc -> 	( # D ) { WCZ } 	%001000011 DCZ ;
pub dirz -> 	( # D ) { WCZ } 	%001000100 DCZ ;
pub dirnz -> 	( # D ) { WCZ } 	%001000101 DCZ ;
pub dirrnd -> 	( # D ) { WCZ } 	%001000110 DCZ ;
pub dirnot -> 	( # D ) { WCZ } 	%001000111 DCZ ;
pub outl -> 	( # D ) { WCZ } 	%001001000 DCZ ;
pub outh -> 	( # D ) { WCZ } 	%001001001 DCZ ;
pub outc -> 	( # D ) { WCZ } 	%001001010 DCZ ;
pub outnc -> 	( # D ) { WCZ } 	%001001011 DCZ ;
pub outz -> 	( # D ) { WCZ } 	%001001100 DCZ ;
pub outnz -> 	( # D ) { WCZ } 	%001001101 DCZ ;
pub outrnd -> 	( # D ) { WCZ } 	%001001110 DCZ ;
pub outnot -> 	( # D ) { WCZ } 	%001001111 DCZ ;
pub fltl -> 	( # D ) { WCZ } 	%001010000 DCZ ;
pub flth -> 	( # D ) { WCZ } 	%001010001 DCZ ;
pub fltc -> 	( # D ) { WCZ } 	%001010010 DCZ ;
pub fltnc -> 	( # D ) { WCZ } 	%001010011 DCZ ;
pub fltz -> 	( # D ) { WCZ } 	%001010100 DCZ ;
pub fltnz -> 	( # D ) { WCZ } 	%001010101 DCZ ;
pub fltrnd -> 	( # D ) { WCZ } 	%001010110 DCZ ;
pub fltnot -> 	( # D ) { WCZ } 	%001010111 DCZ ;
pub drvl -> 	( # D ) { WCZ } 	%001011000 DCZ ;
pub drvh -> 	( # D ) { WCZ } 	%001011001 DCZ ;
pub drvc -> 	( # D ) { WCZ } 	%001011010 DCZ ;
pub drvnc -> 	( # D ) { WCZ } 	%001011011 DCZ ;
pub drvz -> 	( # D ) { WCZ } 	%001011100 DCZ ;
pub drvnz -> 	( # D ) { WCZ } 	%001011101 DCZ ;
pub drvrnd -> 	( # D ) { WCZ } 	%001011110 DCZ ;
pub drvnot -> 	( # D ) { WCZ } 	%001011111 DCZ ;

	*** SMARTPINS ***

pub rqpin -> 		 ( d # s ) { WC }	%1010100_000 +C +I DSOP ;
pub rdpin -> 		 ( d # s ) { WC }	%1010100_010 +C +I DSOP ;
pub akpin -> 		 ( # s )		%000000001 %110000001_0 DSI ;
pub wrpin -> 		 ( # d # s )		%11000000_00 DSLI ;
pub wxpin -> 		 ( # d # s )		%11000001_00 DSLI ;
pub wypin -> 		 ( # d # s )		%11000010_00 DSLI ;
pub setdacs -> 		 ( # d )		%000011100 DSI0 ;
pub setscp -> 		 ( # d )		%001110000 DSI0 ;
pub getscp -> 		 ( d )			%001110001 %1101011000 DSOP ;

	*** LUT ***
{

I believe the only instruction encodings that changed are the PTRA/PTRB encodings and the addition of the use of the pointers with RDLUT/WRLUT. 
The immediate source for the RDLUT/WRLUT instructions must be less than $100. 
Immediate values of $100 and above are now used for the pointers. 
The RevA PTRA/PTRB encodings are a subset of the RevB encodings, so this will work as long as the offsets are within the range of -16 to +15. 	
}
pub wrlut -> 		 ( # d # s/p )		%11000011_0_0 DSLI ;
pub rdlut -> 		 ( d # s/p ) 		%1010101_000 DSCZI ;
pub setluts -> 		 ( # d -- )		%000110111 DSI0 ;

	*** COLORSPACE ***

pub setcy -> 		 ( # d -- )		%000111000 DSI0 ;
pub setci -> 		 ( # d -- )		%000111001 DSI0 ;
pub setcq -> 		 ( # d -- )		%000111010 DSI0 ;
pub setcfrq -> 		 ( # d -- )		%000111011 DSI0 ;
pub setcmod -> 		 ( # d -- )		%000111100 DSI0 ;

	*** PIXEL ***

pub setpiv -> 		 ( # d -- )		%000111101 DSI0 ;
pub setpix -> 		 ( # d -- )		%000111110 DSI0 ;
pub addpix -> 		 ( d s -- )		%101001000_0 DSI ;
pub mulpix -> 		 ( d s -- )		%101001001_0 DSI ;
pub blnpix -> 		 ( d s -- )		%101001010_0 DSI ;
pub mixpix -> 		 ( d s -- )		%101001011_0 DSI ;
pub rgbsqz -> 		 ( d -- )		%001100110 %1101011000 -CZI DSOP ;
pub rgbexp -> 		 ( d -- )		%001100111 %1101011000 -CZI DSOP ;

	*** MISC ***

pub setq -> 		 ( #d -- )		%000101000 DSI0 ;
pub setq2 -> 		 ( #d -- )		%000101001 DSI0 ;
pub push -> 		  ( #d -- )		%000101010 DSI0 ;
pub pop -> 		  ( #d -- )		%000101011 %110101100_0	DSCZ ;
pub getct -> 		 ( d -- )		%000011010 %110101100_0 DSC ;
--- 2 forms, one with d and one with no dest but must use wc/wz/wcz
pub getrnd -> 		 ( d -- )		ADEPTH 0= IF 0 #s THEN  %000011011 %1101011_00_0 DSCZI ;
pub waitx -> 		 ( # d -- )		%000011111 %1101011_00_0 DSCZI ;
pub nop -> 					0 ASM, ;


	*** BRANCHING MACROS ***

pub FOR: ( n reg -- addr )	-> ADEPTH IF 2DUP <> IF SWAP mov ELSE 2DROP THEN THEN PC ;
pub NEXT: ( addr reg -- )	-> SWAP #s REL9 %101101101_0 DSI ;
pub BEGIN: ( -- pc )		PC ;
pub AGAIN: ( pc -- )		jmp ;
pub UNTIL: ( pc <cond> -- )	jmp ;	( {NZ} UNTIL, )


	--- simple labels ---

8 longs _locals
byte _lp
pri @l			_lp C@ 4* _locals + ;

pri label: ( index -- )
 	_lp C!
	@l @ IF
---	go back and resolve forward reference (works for djnz at present)
	@l @ C@ $FF = IF PC @l @ 4+ - 4/ $1FF - @l @ +! THEN
	ELSE PC @l ! THEN
	;

---			get address or use PC and set if not defineds
pri @label		_lp C! @l @ IF @l @ ELSE PC DUP @l ! THEN

pub .l0				0 label: ;
pub l0				0 @label ;
pub .l1				1 label: ;
pub l1				1 @label ;
pub .l2				2 label: ;
pub l2				2 @label ;
pub .l3				3 label: ;
pub l3				3 @label ;
pub .l4				4 label: ;
pub l4				4 @label ;
pub .l5				5 label: ;
pub l5				5 @label ;
pub .l6				6 label: ;
pub l6				6 @label ;
pub .l7				7 label: ;
pub l7				7 @label ;

256 bytes labels
pri +LABEL ( str )		labels DUP LEN$ + $! ;

pub :: 	( <label> -- )		GET$ +LABEL ;



	*** TAQOZ KERNEL ***


pub EXIT;		AT 0EXIT 2+ JMP\, ;
pub >POPX		AT DROP CALL\, ;
pub DROP;		AT DROP JMP\, ;
pub 2DROP;		AT 2DROP JMP\, ;
pub 3DROP;		AT 3DROP JMP\, ;

pub >PUSHX		AT DUP 1+ CALL\,  ;
pub >ROT		AT ROT CALL\, ;
pub >SWAP		AT SWAP CALL\, ;
pub >I			AT I CALL\, ;
pub >SPIRD		AT SPIRD CALL\, ;
pub >SPIWB		AT SPIWB CALL\, ;
pub >SPICE		AT SPICE CALL\, ;


	*** INPUT, PARSING, & EVALUATION ***



long nx'	--- eval string ptr
byte nxrd
word ukey1
--- EVAL KEY INPUT (via linebuf normally)
pri EVALKEY	nx' @ nxrd C@ + C@ DUP IF nxrd C++ ELSE ukey1 W@ ukey W! THEN ;

512 bytes symbols
{
Simple symbol table - entry[16] = string[11],0,long
Use: 0 SYMBOL  to clear table
always returns symbol table address and a the string addr if not first time
else a false flag
}

pri @TYPE		11 + ;
pri @LINK		12 + ;
pri ABS!		DUP @ $FFFFF ANDN ROT OR SWAP ! ;

pri OLDLABEL ( labflg str sym )
\  	."  OLD "
	  NIP SWAP IF ( sym ) --- refd and now can be resolved --- assume single ref for now
\ 	."  +RESOLVE"
	  PC SWAP @lINK @ ABS!
	  ELSE --- redf again ( need to allow linking )
\ 	  ."  AGAIN"
	  @lINK @ EXIT
	  THEN
	  ;

pri NEWLABEL ( labflg str sym )
\	."  NEW "
--- NEW LABEL - append to symbol table
	SWAP OVER $! ( labflg sym )
 	SWAP ( sym labflg )
---	NEW LABEL - in label column or forward reference?
	  IF ( new label )
\	    ." LABEL "
	    'L' OVER @TYPE C!
	    PC SWAP @LINK !
	  ELSE
\	    ."  REFERENCE "
	    'F' OVER @TYPE C!
	    PC OVER @lINK ! PC
	  THEN
	;

pri SYMBOL ( str -- symptr str/false ) ( 0 -- )
	?DUP IF
	  DUP LEN$ nxrd C@ 2- => SWAP ( labflg str )
	  symbols ( labflg str sym )
	  BEGIN DUPC@
	  WHILE 2DUP $= IF OLDLABEL EXIT THEN
	    16 +
	  REPEAT ( labflg str sym)
	  NEWLABEL
	ELSE
	  symbols 512 ERASE
	THEN
	;


pub CALL$ ( string -- )
	DUP C@
	IF DUP SEARCH ( str nfa )
	  ?DUP IF NIP CFA CALL
	  ELSE ( str ) SYMBOL
	  THEN
	ELSE DROP
	THEN
	;

byte cflg
pri EVALUATE ( str -- )
	cflg C~
---	pad out with a space
	$20 OVER DUP LEN$ + W!
---	set string ptrs
	nx' ! nxrd C~
--- point to EVALKEY input
	ukey W@ ukey1 W! ' EVALKEY ukey W!
	BEGIN GET$ DUP LEN$ WHILE cflg C@ IF SEARCH CFA cflg C~  ELSE NUMBER 0= IF @WORD CALL$ THEN  THEN REPEAT
	DROP
	;


pri  ''	cflg C~~ ;		\ GET$ SEARCH DUP IF CFA CALL THEN ;


byte keywr
128 bytes linebuf

pri PUTCH	linebuf keywr C@ + W! keywr C++ ;
pri PUT$	BEGIN DUP C@ WHILE DUP C@ PUTCH 1+ REPEAT DROP ;
pri BSCH	keywr C-- ;

pri TIAKEY
	SWITCH
	$1B 	CASE " end"  EVALUATE !SP CONSOLE BREAK
	^X 	CASE linebuf PRINT$ $0D SWITCH BREAK
	8 	CASE keywr C@ IF 8 EMIT SPACE 8 EMIT BSCH 0 PUTCH BSCH THEN BREAK
	'#' 	CASE " #s " PUT$ '#' ?EMIT BREAK
	'['	CASE $20 PUTCH CASE@ ?EMIT BREAK
	']'	CASE $1F ANDN OVER %1100000 AND IF $1F AND THEN $3F AND + BREAK
---	skip ' comments
	''' 	CASE CASE@ ?EMIT BEGIN WKEY DUP ?EMIT $0D = UNTIL $0D SWITCH THEN
---	always treat a  ,  as a special delimiter ,,
	',' 	CASE "  ,, " PUT$ CASE@ ?EMIT BREAK
---	treat \ as absolute address symbol aa internally (Forth uses \)
	'\' 	CASE " aa " PUT$ CASE@ ?EMIT BREAK

	'@' 	CASE " '' " PUT$ CASE@ ?EMIT BREAK
---	convert tab to a space
	9 	CASE $20 PUTCH 9 ?EMIT BREAK
	$20 	CASE CASE@ DUP ?EMIT PUTCH BREAK
	$0D 	CASE keywr C@ 1 > IF $20 PUTCH $0D PUTCH THEN BREAK
	CASE@ $20 < ?EXIT
---	otherwise just echo and buffer character
	CASE@ DUP ?EMIT PUTCH
	;

pri GETLINE ( -- str )
	INDENT $0F cc! eff C~ DEPTH _adepth C! aflgs C~
	keywr C~ BEGIN WKEY TIAKEY CASE@ $0D = keywr C@ 1 > AND UNTIL
	linebuf
	;


--- Create a new vocabulary that spans from here back to the start of the assembler
VOCAB ASSEMBLER *P2ASM*
--- Now reset the vocab stack to Forth and then switch to ASSEMBLER vocab
FORTH ASSEMBLER

{
TAQOZ# NFA' CODE QD ---
---                      ---LINK FIELD---
0B229: 84 43 4F 44  45 98 84 00  80 6B C4 47  47 45 54 4C     '.CODE....k.GGETL'
0B239: 49 4E 45 70  84 45 44 4F  4B 45 59 88  83 44 42 53     'INEp.EDOKEY..DBS' ok
}
--- create a CODE defining word that automatically compiles the ASM word to execute in-line code
pre CODE
	[C] CREATE$ AT (CODE)
	_l C~
pri TIA:
	FORTH ASSEMBLER
	_locals 32 ERASE
	warnings C~ DEPTH 1- _cdepth C!
	symbols C@ 3 = IF 0 SYMBOL THEN
---	Compile ASM code to call following assembly code, then stop compiling
	[C] [W] [C] [
---	use as asm/end flag
	1 flags SET
---	use code memory for assembly but keep temp code out of the way
	HERE _pc !  BUFFERS @HERE W!
	AT SYMBOL unum W!
	BEGIN GETLINE keywr C@ 1 > IF EVALUATE <-  THEN  1 flags SET? 0= UNTIL
	;

pub end
\ pub ASM;
pub END-CODE
	FORTH \ OFF TIA ( hide assembler lexicon )
---	EXIT               fix up compilation ptr
	$4D PC DUP @HERE ! DUP uhere 4+ ! W!
	1 flags CLR unum W~
	DEPTH _cdepth C@ <> IF PRINT"   Stack mismatch! " WARN THEN
	warnings C@ ?DUP IF . PRINT"  warnings " THEN
	CR
	;

1 COG@ $1FF AND := doNEXT
--- switch from inline assembly back to Forth threads and continue compiling
\ pub FORTH:	AT (FORTH) CALL\,  end [C] ] ;
pub FORTH:	PTRA doNEXT #s CALLDS, end [C] ] ;
pre ASM:	AT (ASM) TIA: ;

pub LISTING			_l C! ;



END
