'#######################################################################'
' 	P2.inc
'#######################################################################'
CON

{
_XTALFREQ     = 20_000_000                                    ' crystal frequency
 _XDIV         = 4             '\                              '\ crystal divider                      to give 5.0MHz
 _XMUL         = 72            '| 180MHz                       '| crystal / div * mul                  to give 360MHz
 _XDIVP        = 2             '/                              '/ crystal / div * mul /divp            to give 180MHz
 _XOSC         = %10                                   'OSC    ' %00=OFF, %01=OSC, %10=15pF, %11=30pF
 _XSEL         = %11                                   'XI+PLL ' %00=rcfast(20+MHz), %01=rcslow(~20KHz), %10=XI(5ms), %11=XI+PLL(10ms)
 _XPPPP        = ((_XDIVP>>1) + 15) & $F                       ' 1->15, 2->0, 4->1, 6->2...30->14
 _CLOCKFREQ    = _XTALFREQ / _XDIV * _XMUL / _XDIVP            ' internal clock frequency
 _SETFREQ      = 1<<24 + (_XDIV-1)<<18 + (_XMUL-1)<<8 + _XPPPP<<4 + _XOSC<<2  ' %0000_000e_dddddd_mmmmmmmmmm_pppp_cc_00  ' setup  oscillator
 _ENAFREQ      = _SETFREQ + _XSEL                                             ' %0000_000e_dddddd_mmmmmmmmmm_pppp_cc_ss  ' enable oscillator
}

'		     XIDIV  XIMUL       VCODIV
' CLOCK MODE 	= %E_DDDD_DDMM_MMMM_MMMM_PPPP_CCSS
PLLEN		= %1_0000_0000_0000_0000_0000_0000
NOXI		= %0_0000_0000_0000_0000_0000_0000
PF0		= %0_0000_0000_0000_0000_0000_0100
PF15		= %0_0000_0000_0000_0000_0000_1000
PF30		= %0_0000_0000_0000_0000_0000_1100

_RCFAST		= %0_0000_0000_0000_0000_0000_0000
_RCSLOW		= %0_0000_0000_0000_0000_0000_0001
XINCLK		= %0_0000_0000_0000_0000_0000_0010	' use XIN
PLLCLK		= %0_0000_0000_0000_0000_0000_0011	' use PLL

' The PLL output frequency will be Freq(VCO) if %PPPP = 15, else Freq(VCO) / (%PPPP + 1) / 2.
XIDIV		= 1			' crystal/osc input divider'
VCODIV		= 1
CLKMUL		= CPUHZ/(XIN/XIDIV)
CLKCFG		= 1<<24+(XIDIV-1)<<18+(CLKMUL-1)<<8+((VCODIV-2)&$0F)<<4+PF15



baudval         = (cpuhz/baud_rate)<<16



' SERIAL COMS
rx_pin		= 63		'pin serial receiver
tx_pin		= 62		'pin serial transmitter
' SPI FLASH
spi_cs		= 61		'pin SPI memory select		(also sd_ck)
spi_ck		= 60		'pin SPI memory clock		(also sd_cs)
spi_di		= 59		'pin SPI memory data in		(also sd_di)
spi_do		= 58		'pin SPI memory data out	(also sd_do)
' SD CARD
sd_cs		= spi_ck
sd_ck		= spi_cs
sd_di		= spi_di
sd_do		= spi_do
