CON

XIN			= 20_000_000
xmode		= 3			' 2 for xtal, 3 for osc'
CPUHZ		= 200_000_000		' desired CPU clock frequency'
baud_rate   = 115200		' console baud rate - timing value calculated at startup'
morestops	= 2			' extra stop bits for USB or terminal esp. at higher baud rates

include(`P2.inc')
include(`memmap.inc')

{ I/O PINS
P63	RXD
P62	TXD
P61	SFCS SDCK
P60	SFCK SDCS
P59	SFDI SDDI
P58	SFDO SDDO
P57	SDA
P56	SCL
-
P55
P54	PS2CLK
P53	PS2DAT
P52	VS
P51	RED
P50	GRN
P49	BLU
P48	HS
-
P47
P46
P45
P44
P43
P42
P41
P40
-
P39
P38
P37
P36
P35
P34
P33
P32

_VGACFG		long	$03020100	''$33323130		' VGA RGBH pins on P48..P52
		long	$04	''$34			' VSYNCH'
_VGAINIT	long	@vgainit		' VGA code '
_VGASET		long	round(fset)
_KBCFG		long	$3635			' PS/2 CLK,DAT' 54,53



}

'************* VGA & KEYBOARD ************* '

vgacog		= 7				' vga runs in this cog '

DAT	' STAGE 1 - BOOT TIME INITIALIZATION '

		orgh	0
		org
		jmp	#initsys

'**************** configuration block **************** '
''
		byte	"P2      "		' 8 character ID'
_OPTIONS	byte	%0000_0011		' options    SD,FLASH
		byte	0,0,0

'	*** CLOCK ***	'
_XIN		long	XIN			' input freqency'
_CPUHZ		long	CPUHZ			' final clock '
_CLKCFG		long	CLKCFG		''$012C_B3FF $014CB3FC '

'	*** SERIAL/VGA/KEYBOARD *** '
_BAUD		long	baud_rate
_VGACFG		long	$03020100	''$33323130		' VGA RGBH pins on P48..P52
		long	$04	''$34			' VSYNCH'
_VGAINIT	long	@vgainit		' VGA code '
_VGASET		long	round(fset)
_KBCFG		long	$3635			' PS/2 CLK,DAT' 54,53

'	*** RESET VECTORS *** '
_RESET		long	@RESET
_IDLE		long	@IDLE
_TERMINAL	long	@TERMINAL		' COG0 TASK'
_COG1		long	0			' COG1 TASK ( 0=none )
_COG2		long	0
_COG3		long	0
_COG4		long	0
_COG5		long	0
_COG6		long	0
_COG7		long	0

include(`init.inc')
include(`trace.p2a')
include(`taqoz.inc')		' defs for TAQOZ '
include(`version.p2a')		' version header '
include(`variables.p2a')	' defs for TAQOZ variables '
include(`kernel.p2a')		' TAQOZ COG CODE'
include(`vga-multi.p2b')	' VGA COG CODE'

include(`hubexec.p2a')		'HUBEXEC CODE AFTER WORDCODE '
include(`i2c.p2a')
include(`serial.p2a')

include(`threads.twc')
include(`flash.twc')
	' sdcard
codeorg

include(`dictionary.twc')
include(`license.txt')
