'#######################################################################'
' 	memmap.inc
'#######################################################################'

' *** MEMORY MAP *** '


registers       = $0200           	'Variables used by kernel + general-purpose

_hubcode	= $0400			' start of TAQOZ code'

THREADS		= $2000

dictorg         = $1F340-$C0   		' dictionary can be moved elsewhere at runtime'
cfgbackup	= $1FF40

config2		= $EB40			' backup of page 0 config for $0C0 bytes'

extvars		= $01800		' EXTEND variables '
datram		= $7E000		' start of data memory (PERHAPS)- user variables '


SDBUFS		= $7F800		' allocate 4 sector buffers'
rxbuffers       = $7F500		' SERIAL RX buffer
  rxsize          = $0300

bmporg		= $33100 '$32B00		' start of bmp header, palette, and bitmap data '


' ****** FLASH *******


flashpart	= $E0000		' Area in serial Flash where an image of TAQOZ can be backed up to'
flashpage	= flashpart>>16
flashsig	= $FFFFC


' Offsets in LUT for stacks
	datstk          = $000		' 32 deep'
	lpstk           = $020		' 190705 combines loop and branch stack - always 3 longs for DO or FOR '
	brastk          = $030
	retstk          = $040		' 64 deep'
	lutfree		= $080
	auxstk		= $080

' The LUT is essentially free from $80 onwards


' LMOVE buffer - no need to allocate more as there is not much speed increase'
	lmbuf		= $180
	  lmsz		= $200-lmbuf
{
************* NEW *************
V2.5
---------TAQOZ DATA--------
00000-0007F	CONFIG
00080-001FF	SPARE (384)
00200-003FF	REGISTERS (512)

-----------ASSEMBLY------------------
00400		COG IMAGES
00E34-017FF	HUBEXEC (Forth and system)

-------- CODED OPS -------------
( ADDRESSES USE FOR CODED OPS )
01800-01BFF	shorts (0..1023)
01C00-01CFF	conditional relative branch
01D00-01DFF	unconditional relative branch
01E00-01FFF	register index (0..511)

( MEMORY USE 2k)
01800		EXTEND/TIA/TIM VARIABLES

------- THREADED CODE ------
02000->>>>>	THREADS
<<<<<-1FF30	DICTIONARY
1FF40		CONFIG BACKUP
(TAQOZ free to grow into page 1 or further)
--------- SPARE-------------
20000-32AFF	SPARE 77824 (Or TAQOZ or BMV BUFFER)

--------- VIDEO ---------
( USAGE VARIES BUT STANDARD VGA SHOWN )
32B00-32BFF	BMP HEADER
32C00-33FFF	PALETTE
33000-7DFFF	SCREEN (6B400 for 720p)

--------USER DATA-----------
7E000		USER DATA

--------BUFFERS-------------
7F500		RX BUFFERS (768)
7F800		FILE BUFFERS (2K)
}
