'#######################################################################'
' 	taqoz.inc
'#######################################################################'

'*******************************************************************************
'*                                                                             *
'*          TAQOZ - Tachyon Forth for the Parallax P2 CPU ROM                  *
'*                                                                             *
'*******************************************************************************


CON

	sys_clk         = CPUHZ
        nscnt           = 100000/(sys_clk/1000000)

' 180524 - implement 10-bit short literals and 9-bit task register addresses for compact fat32 variables'
{
( ADDRESSES USE FOR CODED OPS )
01800-01BFF	shorts (0..1023)
01C00-01CFF	conditional relative branch
01D00-01DFF	unconditional relative branch
01E00-01FFF	register index (0..511)
}
	w               =       $1800           ' wordcode offset for 10-bit literals 0..1023
        _IF             =       $1C00           ' IF relative forward branch 0 to 127 words
        _UNTIL          =       $1C80           ' UNTIL relative reverse branch 0 to 127 words
	GO		=	$1D00
	GOBACK		=	$1D80
	'opunused	= 	$1D00		' ???? could use'
	rg		= 	$1E00          ' task/cog register 8-bit offset


        tasks           = 	registers+$D0   	' 2 longs/task * 8 cogs

        SKIPZ           =       _IF+01		' short-form for _IF+01'

	ex              =       1               ' EXITs (jump to hub wordcode instead of call)

        _FALSE          =       w+0		' quick constants '
        _0              =       w+0
        _1              =       w+1
        _2              =       w+2
        _3              =       w+3
        _4              =       w+4
        _5              =       w+5
        _6              =       w+6
        _7              =       w+7
        _8              =       w+8
        _9              =       w+9
        _13             =       w+13
        _16             =       w+16
        _32             =       w+32
        _BL             =       w+32


	numpadsz        = 44            ' We really only need a large buffer for when long binary numbers with separators are used
	                                ' 26 digits for double number 18,446,744,073,709,551,615
	wordsz          = 44            ' any word including binary numbers up to n characters (1 count, 1 terminator)
	tasksz          = 8             ' 8 bytes/task RUN[2] FLAG[1]


	WW		= $FFFF
